/**
 * 
 */
package newprocess.diagram.cust.annotations.dialogs;

/**
 * Class used as a trivial case of a Annotation 
 * Serves as the business object for the AnnotationTableViewer.
 * 
 * An Annotation has the following properties: url 
 * 
 * @author sh
 */
public class Annotation {
	private String uri = "";
	
	/**
	 * Create an Annotation with an initial url
	 * @param url
	 */
	public Annotation(String url) {
		super();
		setUri(url);
	}
		
	/**
	 * @return String Annotation URI
	 */
	public String getUri() {
		return uri;
	}
	
	/**
	 * sets the "uri" property
	 * @param uri
	 */
	public void setUri(String uri) {
		this.uri = uri;
	}
}
