/**
 * 
 */
package newprocess.diagram.cust.annotations.dialogs;

/**
 * @author sh
 *
 */
public interface IAnnotationViewer {
	/**
	 * Update the view to reflect the fact that an Annotation was added 
	 * to the Annotation list
	 * 
	 * @param annotation
	 */
	public void addAnnotation(Annotation annotation);
	
	/**
	 * Update the view to reflect the fact that an Annotation was removed 
	 * from the Annotation list
	 * 
	 * @param annotation
	 */
	public void removeAnnotation(Annotation annotationl);
	
	/**
	 * Update the view to reflect the fact that one of the Annotation
	 * was modified 
	 * 
	 * @param url
	 */
	public void updateAnnotation(Annotation annotation);
}
