/**
 * 
 */
package newprocess.diagram.cust.figures;

import newprocess.diagram.edit.parts.ConditionTermEditPart;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.RootEditPart;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;


/**
 * 
 * defines a reference to its EditPart and the getter/setter methods.
 * its ugly but needed to do untangling of prox connections.
 *  
 * @author ts
 *
 */
public class TermDefaultSizeNodeFigure extends DefaultSizeNodeFigure {
	
	private EditPart myPort = null;

	/**
	 * @param defSize
	 */
	public TermDefaultSizeNodeFigure(Dimension defSize) {
		super(defSize);
	}

	/**
	 * @param width
	 * @param height
	 */
	public TermDefaultSizeNodeFigure(int width, int height) {
		super(width, height);
	}

	/**
	 * @return the myPort
	 */
	public EditPart getMyPort() {
		return myPort;
	}

	/**
	 * @param myPort the myPort to set
	 */
	public void setMyPort(EditPart myPort) {
		if (myPort instanceof RootEditPart || myPort instanceof ConditionTermEditPart)
			this.myPort = myPort;
	}
}

