package newprocess.diagram.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;

import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.AndOperatorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityActorEditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartment2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartment2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.ConclusionConclusionPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ConclusionConclusionProxyEditPart;
import newprocess.diagram.edit.parts.ConclusionEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.ConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionTermConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.EventEventPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ExpansionEditPart;
import newprocess.diagram.edit.parts.ExpansionExpansionPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ExpansionExpansionProxyEditPart;
import newprocess.diagram.edit.parts.Expression2EditPart;
import newprocess.diagram.edit.parts.Expression3EditPart;
import newprocess.diagram.edit.parts.Expression4EditPart;
import newprocess.diagram.edit.parts.Expression5EditPart;
import newprocess.diagram.edit.parts.Expression6EditPart;
import newprocess.diagram.edit.parts.Expression7EditPart;
import newprocess.diagram.edit.parts.Expression8EditPart;
import newprocess.diagram.edit.parts.ExpressionEditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment2EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment3EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment4EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment5EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment6EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment7EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment8EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartmentEditPart;
import newprocess.diagram.edit.parts.GlobalsEditPart;
import newprocess.diagram.edit.parts.GlobalsGlobalsConditionCompartmentEditPart;
import newprocess.diagram.edit.parts.GlobalsGlobalsLoaderCompartmentEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.ListenerListenerPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.MessageEditPart;
import newprocess.diagram.edit.parts.OperatorTermSubTermEditPart;
import newprocess.diagram.edit.parts.OrOperatorEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.RootEditPart;
import newprocess.diagram.edit.parts.RootTermEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;
import newprocess.diagram.edit.parts.SyncActivitySynActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.SyncActivitySynActivityPreconditionCompartmentEditPart;
import newprocess.diagram.part.New_processVisualIDRegistry;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

/**
 * @generated
 */
public class New_processNavigatorContentProvider implements
		ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	public void dispose() {
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			AdapterFactoryEditingDomain editingDomain = (AdapterFactoryEditingDomain) GMFEditingDomainFactory.INSTANCE
					.createEditingDomain();
			editingDomain.setResourceToReadOnlyMap(new HashMap() {
				public Object get(Object key) {
					if (!containsKey(key)) {
						put(key, Boolean.TRUE);
					}
					return super.get(key);
				}
			});
			ResourceSet resourceSet = editingDomain.getResourceSet();

			org.eclipse.emf.common.util.URI fileURI = org.eclipse.emf.common.util.URI
					.createPlatformResourceURI(file.getFullPath().toString(),
							true);
			Resource resource = resourceSet.getResource(fileURI, true);
			Collection result = new ArrayList();
			result.addAll(createNavigatorItems(selectViewsByType(resource
					.getContents(), ProcessEditPart.MODEL_ID), file, false));
			return result.toArray();
		}

		if (parentElement instanceof New_processNavigatorGroup) {
			New_processNavigatorGroup group = (New_processNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof New_processNavigatorItem) {
			New_processNavigatorItem navigatorItem = (New_processNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (New_processVisualIDRegistry.getVisualID(view)) {

		case ProcessEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup links = new New_processNavigatorGroup(
					"links", "icons/linksNavigatorGroup.gif", parentElement);
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(SyncActivityEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ListenerEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(AsyncActivityEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(EventEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionProxyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ActorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(MessageEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpansionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConclusionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(GlobalsEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(AsyncActivityActorEditPart.VISUAL_ID));
			links
					.addChildren(createNavigatorItems(connectedViews, links,
							false));
			connectedViews = getDiagramLinksByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(RootTermEditPart.VISUAL_ID));
			links
					.addChildren(createNavigatorItems(connectedViews, links,
							false));
			connectedViews = getDiagramLinksByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(OperatorTermSubTermEditPart.VISUAL_ID));
			links
					.addChildren(createNavigatorItems(connectedViews, links,
							false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermConditionProxyEditPart.VISUAL_ID));
			links
					.addChildren(createNavigatorItems(connectedViews, links,
							false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConclusionConclusionProxyEditPart.VISUAL_ID));
			links
					.addChildren(createNavigatorItems(connectedViews, links,
							false));
			connectedViews = getDiagramLinksByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpansionExpansionProxyEditPart.VISUAL_ID));
			links
					.addChildren(createNavigatorItems(connectedViews, links,
							false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}

		case SyncActivityEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(SyncActivitySynActivityPreconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(ExpressionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(SyncActivitySynActivityPostconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(Expression2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case ListenerEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ListenerListenerPreconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(Expression3EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case AsyncActivityEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup outgoinglinks = new New_processNavigatorGroup(
					"outgoing links", "icons/outgoingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(AsyncActivityAsyncActivityPreconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(Expression4EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(AsyncActivityAsyncActivityPostconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(Expression5EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view), New_processVisualIDRegistry
							.getType(AsyncActivityActorEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case EventEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(EventEventPostconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(Expression6EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case ConditionProxyEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup incominglinks = new New_processNavigatorGroup(
					"incoming links", "icons/incomingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(ConditionTermConditionProxyEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConclusionConclusionProxyEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view), New_processVisualIDRegistry
							.getType(ExpansionExpansionProxyEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case ActorEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup incominglinks = new New_processNavigatorGroup(
					"incoming links", "icons/incomingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(AsyncActivityActorEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case ExpansionEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup outgoinglinks = new New_processNavigatorGroup(
					"outgoing links", "icons/outgoingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpansionExpansionPostconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(Expression7EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view), New_processVisualIDRegistry
							.getType(ExpansionExpansionProxyEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case ConclusionEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup outgoinglinks = new New_processNavigatorGroup(
					"outgoing links", "icons/outgoingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConclusionConclusionPostconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(Expression8EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConclusionConclusionProxyEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case GlobalsEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(GlobalsGlobalsLoaderCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(LoaderEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(GlobalsGlobalsConditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(ConditionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case ExpressionEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case RootEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup outgoinglinks = new New_processNavigatorGroup(
					"outgoing links", "icons/outgoingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getOutgoingLinksByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootTermEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case OrOperatorEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup outgoinglinks = new New_processNavigatorGroup(
					"outgoing links", "icons/outgoingLinksNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup incominglinks = new New_processNavigatorGroup(
					"incoming links", "icons/incomingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootTermEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view), New_processVisualIDRegistry
							.getType(OperatorTermSubTermEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view), New_processVisualIDRegistry
							.getType(OperatorTermSubTermEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case AndOperatorEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup outgoinglinks = new New_processNavigatorGroup(
					"outgoing links", "icons/outgoingLinksNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup incominglinks = new New_processNavigatorGroup(
					"incoming links", "icons/incomingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootTermEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view), New_processVisualIDRegistry
							.getType(OperatorTermSubTermEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view), New_processVisualIDRegistry
							.getType(OperatorTermSubTermEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case ConditionTermEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup outgoinglinks = new New_processNavigatorGroup(
					"outgoing links", "icons/outgoingLinksNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup incominglinks = new New_processNavigatorGroup(
					"incoming links", "icons/incomingLinksNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootTermEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view), New_processVisualIDRegistry
							.getType(OperatorTermSubTermEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermConditionProxyEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Expression2EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case Expression3EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment3EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment3EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case Expression4EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment4EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment4EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case Expression5EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment5EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment5EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case Expression6EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment6EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment6EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case Expression7EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment7EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment7EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case Expression8EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(RootEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment8EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpressionExpressionCompartment8EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(connectedViews,
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case AsyncActivityActorEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup source = new New_processNavigatorGroup(
					"source", "icons/linkSourceNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup target = new New_processNavigatorGroup(
					"target", "icons/linkTargetNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getLinksTargetByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(ActorEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(AsyncActivityEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!source.isEmpty()) {
				result.add(source);
			}
			if (!target.isEmpty()) {
				result.add(target);
			}
			return result.toArray();
		}

		case RootTermEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup source = new New_processNavigatorGroup(
					"source", "icons/linkSourceNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup target = new New_processNavigatorGroup(
					"target", "icons/linkTargetNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getLinksTargetByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(OrOperatorEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					New_processVisualIDRegistry.getType(RootEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!source.isEmpty()) {
				result.add(source);
			}
			if (!target.isEmpty()) {
				result.add(target);
			}
			return result.toArray();
		}

		case OperatorTermSubTermEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup source = new New_processNavigatorGroup(
					"source", "icons/linkSourceNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup target = new New_processNavigatorGroup(
					"target", "icons/linkTargetNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getLinksTargetByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(OrOperatorEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(OrOperatorEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(AndOperatorEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!source.isEmpty()) {
				result.add(source);
			}
			if (!target.isEmpty()) {
				result.add(target);
			}
			return result.toArray();
		}

		case ConditionTermConditionProxyEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup source = new New_processNavigatorGroup(
					"source", "icons/linkSourceNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup target = new New_processNavigatorGroup(
					"target", "icons/linkTargetNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getLinksTargetByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(ConditionProxyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConditionTermEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!source.isEmpty()) {
				result.add(source);
			}
			if (!target.isEmpty()) {
				result.add(target);
			}
			return result.toArray();
		}

		case ConclusionConclusionProxyEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup source = new New_processNavigatorGroup(
					"source", "icons/linkSourceNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup target = new New_processNavigatorGroup(
					"target", "icons/linkTargetNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getLinksTargetByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(ConditionProxyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ConclusionEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!source.isEmpty()) {
				result.add(source);
			}
			if (!target.isEmpty()) {
				result.add(target);
			}
			return result.toArray();
		}

		case ExpansionExpansionProxyEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			New_processNavigatorGroup source = new New_processNavigatorGroup(
					"source", "icons/linkSourceNavigatorGroup.gif",
					parentElement);
			New_processNavigatorGroup target = new New_processNavigatorGroup(
					"target", "icons/linkTargetNavigatorGroup.gif",
					parentElement);
			Collection connectedViews = getLinksTargetByType(Collections
					.singleton(view), New_processVisualIDRegistry
					.getType(ConditionProxyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					New_processVisualIDRegistry
							.getType(ExpansionEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!source.isEmpty()) {
				result.add(source);
			}
			if (!target.isEmpty()) {
				result.add(target);
			}
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection getLinksSourceByType(Collection edges, String type) {
		Collection result = new ArrayList();
		for (Iterator it = edges.iterator(); it.hasNext();) {
			Edge nextEdge = (Edge) it.next();
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getLinksTargetByType(Collection edges, String type) {
		Collection result = new ArrayList();
		for (Iterator it = edges.iterator(); it.hasNext();) {
			Edge nextEdge = (Edge) it.next();
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getOutgoingLinksByType(Collection nodes, String type) {
		Collection result = new ArrayList();
		for (Iterator it = nodes.iterator(); it.hasNext();) {
			View nextNode = (View) it.next();
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getIncomingLinksByType(Collection nodes, String type) {
		Collection result = new ArrayList();
		for (Iterator it = nodes.iterator(); it.hasNext();) {
			View nextNode = (View) it.next();
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getChildrenByType(Collection nodes, String type) {
		Collection result = new ArrayList();
		for (Iterator it = nodes.iterator(); it.hasNext();) {
			View nextNode = (View) it.next();
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getDiagramLinksByType(Collection diagrams, String type) {
		Collection result = new ArrayList();
		for (Iterator it = diagrams.iterator(); it.hasNext();) {
			Diagram nextDiagram = (Diagram) it.next();
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection selectViewsByType(Collection views, String type) {
		Collection result = new ArrayList();
		for (Iterator it = views.iterator(); it.hasNext();) {
			View nextView = (View) it.next();
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return ProcessEditPart.MODEL_ID.equals(New_processVisualIDRegistry
				.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection createNavigatorItems(Collection views, Object parent,
			boolean isLeafs) {
		Collection result = new ArrayList();
		for (Iterator it = views.iterator(); it.hasNext();) {
			result.add(new New_processNavigatorItem((View) it.next(), parent,
					isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof New_processAbstractNavigatorItem) {
			New_processAbstractNavigatorItem abstractNavigatorItem = (New_processAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
