package newprocess.diagram.navigator;

import newprocess.ConditionProxy;
import newprocess.Element;
import newprocess.Expression;

import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.ActorNameEditPart;
import newprocess.diagram.edit.parts.AndOperatorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityActorEditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.AsyncActivityName2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityNameEditPart;
import newprocess.diagram.edit.parts.ConclusionConclusionProxyEditPart;
import newprocess.diagram.edit.parts.ConclusionEditPart;
import newprocess.diagram.edit.parts.ConclusionNameEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.ConditionNameEditPart;
import newprocess.diagram.edit.parts.ConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionProxyProxyNameEditPart;
import newprocess.diagram.edit.parts.ConditionTermConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.EventNameEditPart;
import newprocess.diagram.edit.parts.ExpansionEditPart;
import newprocess.diagram.edit.parts.ExpansionExpansionProxyEditPart;
import newprocess.diagram.edit.parts.ExpansionNameEditPart;
import newprocess.diagram.edit.parts.Expression2EditPart;
import newprocess.diagram.edit.parts.Expression3EditPart;
import newprocess.diagram.edit.parts.Expression4EditPart;
import newprocess.diagram.edit.parts.Expression5EditPart;
import newprocess.diagram.edit.parts.Expression6EditPart;
import newprocess.diagram.edit.parts.Expression7EditPart;
import newprocess.diagram.edit.parts.Expression8EditPart;
import newprocess.diagram.edit.parts.ExpressionEditPart;
import newprocess.diagram.edit.parts.GlobalsEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.ListenerNameEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.LoaderNameEditPart;
import newprocess.diagram.edit.parts.MessageEditPart;
import newprocess.diagram.edit.parts.MessageNameEditPart;
import newprocess.diagram.edit.parts.OperatorTermSubTermEditPart;
import newprocess.diagram.edit.parts.OrOperatorEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.RootEditPart;
import newprocess.diagram.edit.parts.RootTermEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;
import newprocess.diagram.edit.parts.SyncActivityNameEditPart;

import newprocess.diagram.part.New_processDiagramEditorPlugin;
import newprocess.diagram.part.New_processVisualIDRegistry;

import newprocess.diagram.providers.New_processElementTypes;

import org.eclipse.core.runtime.IAdaptable;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;

import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;

import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import org.eclipse.gmf.runtime.notation.View;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;

import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;

import org.eclipse.swt.graphics.Image;

import org.eclipse.ui.IMemento;

import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class New_processNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		New_processDiagramEditorPlugin.getInstance().getImageRegistry().put(
				"Navigator?InvalidElement",
				ImageDescriptor.getMissingImageDescriptor());
		New_processDiagramEditorPlugin.getInstance().getImageRegistry().put(
				"Navigator?UnknownElement",
				ImageDescriptor.getMissingImageDescriptor());
		New_processDiagramEditorPlugin.getInstance().getImageRegistry().put(
				"Navigator?ImageNotFound",
				ImageDescriptor.getMissingImageDescriptor());
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof New_processNavigatorItem
				&& !isOwnView(((New_processNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof New_processNavigatorGroup) {
			New_processNavigatorGroup group = (New_processNavigatorGroup) element;
			return New_processDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof New_processNavigatorItem) {
			New_processNavigatorItem navigatorItem = (New_processNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (New_processVisualIDRegistry.getVisualID(view)) {
		case SyncActivityEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?SyncActivity",
					New_processElementTypes.SyncActivity_2001);
		case ListenerEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?Listener",
					New_processElementTypes.Listener_2002);
		case AsyncActivityEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?AsyncActivity",
					New_processElementTypes.AsyncActivity_2003);
		case EventEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?Event",
					New_processElementTypes.Event_2005);
		case ConditionProxyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?ConditionProxy",
					New_processElementTypes.ConditionProxy_2006);
		case ActorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?Actor",
					New_processElementTypes.Actor_2007);
		case MessageEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?Message",
					New_processElementTypes.Message_2008);
		case ExpansionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?Expansion",
					New_processElementTypes.Expansion_2009);
		case ConclusionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?Conclusion",
					New_processElementTypes.Conclusion_2010);
		case GlobalsEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.wilken.de/mod/newprocess?Globals",
					New_processElementTypes.Globals_2011);
		case ExpressionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Expression",
					New_processElementTypes.Expression_3001);
		case RootEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Root",
					New_processElementTypes.Root_3002);
		case OrOperatorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?OrOperator",
					New_processElementTypes.OrOperator_3003);
		case AndOperatorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?AndOperator",
					New_processElementTypes.AndOperator_3004);
		case ConditionTermEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?ConditionTerm",
					New_processElementTypes.ConditionTerm_3005);
		case Expression2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Expression",
					New_processElementTypes.Expression_3006);
		case Expression3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Expression",
					New_processElementTypes.Expression_3007);
		case Expression4EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Expression",
					New_processElementTypes.Expression_3008);
		case Expression5EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Expression",
					New_processElementTypes.Expression_3009);
		case Expression6EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Expression",
					New_processElementTypes.Expression_3010);
		case Expression7EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Expression",
					New_processElementTypes.Expression_3011);
		case Expression8EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Expression",
					New_processElementTypes.Expression_3012);
		case LoaderEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Loader",
					New_processElementTypes.Loader_3013);
		case ConditionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.wilken.de/mod/newprocess?Condition",
					New_processElementTypes.Condition_3014);
		case ProcessEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://www.wilken.de/mod/newprocess?Process",
					New_processElementTypes.Process_1000);
		case AsyncActivityActorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.wilken.de/mod/newprocess?AsyncActivity?actor",
					New_processElementTypes.AsyncActivityActor_4001);
		case RootTermEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.wilken.de/mod/newprocess?Root?term",
					New_processElementTypes.RootTerm_4002);
		case OperatorTermSubTermEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.wilken.de/mod/newprocess?OperatorTerm?subTerm",
					New_processElementTypes.OperatorTermSubTerm_4003);
		case ConditionTermConditionProxyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.wilken.de/mod/newprocess?ConditionTerm?conditionProxy",
					New_processElementTypes.ConditionTermConditionProxy_4004);
		case ConclusionConclusionProxyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.wilken.de/mod/newprocess?Conclusion?conclusionProxy",
					New_processElementTypes.ConclusionConclusionProxy_4005);
		case ExpansionExpansionProxyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.wilken.de/mod/newprocess?Expansion?expansionProxy",
					New_processElementTypes.ExpansionExpansionProxy_4006);
		default:
			return getImage("Navigator?UnknownElement", null);
		}
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = New_processDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& New_processElementTypes.isKnownElementType(elementType)) {
			image = New_processElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound");
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof New_processNavigatorGroup) {
			New_processNavigatorGroup group = (New_processNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof New_processNavigatorItem) {
			New_processNavigatorItem navigatorItem = (New_processNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		switch (New_processVisualIDRegistry.getVisualID(view)) {
		case SyncActivityEditPart.VISUAL_ID:
			return getSyncActivity_2001Text(view);
		case ListenerEditPart.VISUAL_ID:
			return getListener_2002Text(view);
		case AsyncActivityEditPart.VISUAL_ID:
			return getAsyncActivity_2003Text(view);
		case EventEditPart.VISUAL_ID:
			return getEvent_2005Text(view);
		case ConditionProxyEditPart.VISUAL_ID:
			return getConditionProxy_2006Text(view);
		case ActorEditPart.VISUAL_ID:
			return getActor_2007Text(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2008Text(view);
		case ExpansionEditPart.VISUAL_ID:
			return getExpansion_2009Text(view);
		case ConclusionEditPart.VISUAL_ID:
			return getConclusion_2010Text(view);
		case GlobalsEditPart.VISUAL_ID:
			return getGlobals_2011Text(view);
		case ExpressionEditPart.VISUAL_ID:
			return getExpression_3001Text(view);
		case RootEditPart.VISUAL_ID:
			return getRoot_3002Text(view);
		case OrOperatorEditPart.VISUAL_ID:
			return getOrOperator_3003Text(view);
		case AndOperatorEditPart.VISUAL_ID:
			return getAndOperator_3004Text(view);
		case ConditionTermEditPart.VISUAL_ID:
			return getConditionTerm_3005Text(view);
		case Expression2EditPart.VISUAL_ID:
			return getExpression_3006Text(view);
		case Expression3EditPart.VISUAL_ID:
			return getExpression_3007Text(view);
		case Expression4EditPart.VISUAL_ID:
			return getExpression_3008Text(view);
		case Expression5EditPart.VISUAL_ID:
			return getExpression_3009Text(view);
		case Expression6EditPart.VISUAL_ID:
			return getExpression_3010Text(view);
		case Expression7EditPart.VISUAL_ID:
			return getExpression_3011Text(view);
		case Expression8EditPart.VISUAL_ID:
			return getExpression_3012Text(view);
		case LoaderEditPart.VISUAL_ID:
			return getLoader_3013Text(view);
		case ConditionEditPart.VISUAL_ID:
			return getCondition_3014Text(view);
		case ProcessEditPart.VISUAL_ID:
			return getProcess_1000Text(view);
		case AsyncActivityActorEditPart.VISUAL_ID:
			return getAsyncActivityActor_4001Text(view);
		case RootTermEditPart.VISUAL_ID:
			return getRootTerm_4002Text(view);
		case OperatorTermSubTermEditPart.VISUAL_ID:
			return getOperatorTermSubTerm_4003Text(view);
		case ConditionTermConditionProxyEditPart.VISUAL_ID:
			return getConditionTermConditionProxy_4004Text(view);
		case ConclusionConclusionProxyEditPart.VISUAL_ID:
			return getConclusionConclusionProxy_4005Text(view);
		case ExpansionExpansionProxyEditPart.VISUAL_ID:
			return getExpansionExpansionProxy_4006Text(view);
		default:
			return getUnknownElementText(view);
		}
	}

	/**
	 * @generated
	 */
	private String getSyncActivity_2001Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(SyncActivityNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.SyncActivity_2001;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getListener_2002Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(ListenerNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.Listener_2002;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getAsyncActivity_2003Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(AsyncActivityNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.AsyncActivity_2003;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getEvent_2005Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(EventNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.Event_2005;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getConditionProxy_2006Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(ConditionProxyProxyNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.ConditionProxy_2006;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5012);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getActor_2007Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(ActorNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.Actor_2007;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5006);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getMessage_2008Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(MessageNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.Message_2008;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5007);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getExpansion_2009Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(ExpansionNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.Expansion_2009;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5008);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getConclusion_2010Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(ConclusionNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.Conclusion_2010;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5009);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getGlobals_2011Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getExpression_3001Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Expression) domainModelElement).getExpression();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3001);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getRoot_3002Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getOrOperator_3003Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getAndOperator_3004Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getConditionTerm_3005Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getExpression_3006Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Expression) domainModelElement).getExpression();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3006);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getExpression_3007Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Expression) domainModelElement).getExpression();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3007);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getExpression_3008Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Expression) domainModelElement).getExpression();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3008);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getExpression_3009Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Expression) domainModelElement).getExpression();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3009);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getExpression_3010Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Expression) domainModelElement).getExpression();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3010);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getExpression_3011Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Expression) domainModelElement).getExpression();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3011);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getExpression_3012Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Expression) domainModelElement).getExpression();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3012);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getLoader_3013Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(LoaderNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.Loader_3013;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5010);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getCondition_3014Text(View view) {
		IParser parser = ParserService.getInstance().getParser(
				new IAdaptable() {
					public Object getAdapter(Class adapter) {
						if (String.class.equals(adapter)) {
							return New_processVisualIDRegistry
									.getType(ConditionNameEditPart.VISUAL_ID);
						}
						if (IElementType.class.equals(adapter)) {
							return New_processElementTypes.Condition_3014;
						}
						return null;
					}
				});
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5011);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getProcess_1000Text(View view) {
		EObject domainModelElement = view.getElement();
		if (domainModelElement != null) {
			return ((Element) domainModelElement).getName();
		} else {
			New_processDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 1000);
			return "";
		}
	}

	/**
	 * @generated
	 */
	private String getAsyncActivityActor_4001Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getRootTerm_4002Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getOperatorTermSubTerm_4003Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getConditionTermConditionProxy_4004Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getConclusionConclusionProxy_4005Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getExpansionExpansionProxy_4006Text(View view) {
		return "";
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">";
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return ProcessEditPart.MODEL_ID.equals(New_processVisualIDRegistry
				.getModelID(view));
	}

}
