package newprocess.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantProvider;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartment2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartment2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.ConclusionConclusionPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ConclusionEditPart;
import newprocess.diagram.edit.parts.ConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.EventEventPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ExpansionEditPart;
import newprocess.diagram.edit.parts.ExpansionExpansionPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.Expression2EditPart;
import newprocess.diagram.edit.parts.Expression3EditPart;
import newprocess.diagram.edit.parts.Expression4EditPart;
import newprocess.diagram.edit.parts.Expression5EditPart;
import newprocess.diagram.edit.parts.Expression6EditPart;
import newprocess.diagram.edit.parts.Expression7EditPart;
import newprocess.diagram.edit.parts.Expression8EditPart;
import newprocess.diagram.edit.parts.ExpressionEditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment2EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment3EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment4EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment5EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment6EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment7EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment8EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartmentEditPart;
import newprocess.diagram.edit.parts.GlobalsEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.ListenerListenerPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.RootEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;
import newprocess.diagram.edit.parts.SyncActivitySynActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.SyncActivitySynActivityPreconditionCompartmentEditPart;

import newprocess.diagram.part.New_processDiagramEditorPlugin;

/**
 * @generated
 */
public class New_processModelingAssistantProvider extends
		ModelingAssistantProvider {

	/**
	 * @generated
	 */
	public List getTypesForPopupBar(IAdaptable host) {
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof SyncActivityEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Expression_3001);
			types.add(New_processElementTypes.Expression_3006);
			return types;
		}
		if (editPart instanceof ListenerEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Expression_3007);
			return types;
		}
		if (editPart instanceof AsyncActivityEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Expression_3008);
			types.add(New_processElementTypes.Expression_3009);
			return types;
		}
		if (editPart instanceof EventEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Expression_3010);
			return types;
		}
		if (editPart instanceof ExpansionEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Expression_3011);
			return types;
		}
		if (editPart instanceof ConclusionEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Expression_3012);
			return types;
		}
		if (editPart instanceof GlobalsEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Loader_3013);
			types.add(New_processElementTypes.Condition_3014);
			return types;
		}
		if (editPart instanceof ExpressionEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Root_3002);
			types.add(New_processElementTypes.ConditionTerm_3005);
			return types;
		}
		if (editPart instanceof Expression2EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Root_3002);
			types.add(New_processElementTypes.ConditionTerm_3005);
			return types;
		}
		if (editPart instanceof Expression3EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Root_3002);
			types.add(New_processElementTypes.ConditionTerm_3005);
			return types;
		}
		if (editPart instanceof Expression4EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Root_3002);
			types.add(New_processElementTypes.ConditionTerm_3005);
			return types;
		}
		if (editPart instanceof Expression5EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Root_3002);
			types.add(New_processElementTypes.ConditionTerm_3005);
			return types;
		}
		if (editPart instanceof Expression6EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Root_3002);
			types.add(New_processElementTypes.ConditionTerm_3005);
			return types;
		}
		if (editPart instanceof Expression7EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Root_3002);
			types.add(New_processElementTypes.ConditionTerm_3005);
			return types;
		}
		if (editPart instanceof Expression8EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.Root_3002);
			types.add(New_processElementTypes.ConditionTerm_3005);
			return types;
		}
		if (editPart instanceof ExpressionExpressionCompartmentEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.OrOperator_3003);
			types.add(New_processElementTypes.AndOperator_3004);
			return types;
		}
		if (editPart instanceof ExpressionExpressionCompartment2EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.OrOperator_3003);
			types.add(New_processElementTypes.AndOperator_3004);
			return types;
		}
		if (editPart instanceof ExpressionExpressionCompartment3EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.OrOperator_3003);
			types.add(New_processElementTypes.AndOperator_3004);
			return types;
		}
		if (editPart instanceof ExpressionExpressionCompartment4EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.OrOperator_3003);
			types.add(New_processElementTypes.AndOperator_3004);
			return types;
		}
		if (editPart instanceof ExpressionExpressionCompartment5EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.OrOperator_3003);
			types.add(New_processElementTypes.AndOperator_3004);
			return types;
		}
		if (editPart instanceof ExpressionExpressionCompartment6EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.OrOperator_3003);
			types.add(New_processElementTypes.AndOperator_3004);
			return types;
		}
		if (editPart instanceof ExpressionExpressionCompartment7EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.OrOperator_3003);
			types.add(New_processElementTypes.AndOperator_3004);
			return types;
		}
		if (editPart instanceof ExpressionExpressionCompartment8EditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.OrOperator_3003);
			types.add(New_processElementTypes.AndOperator_3004);
			return types;
		}
		if (editPart instanceof ProcessEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.SyncActivity_2001);
			types.add(New_processElementTypes.Listener_2002);
			types.add(New_processElementTypes.AsyncActivity_2003);
			types.add(New_processElementTypes.Event_2005);
			types.add(New_processElementTypes.ConditionProxy_2006);
			types.add(New_processElementTypes.Actor_2007);
			types.add(New_processElementTypes.Message_2008);
			types.add(New_processElementTypes.Expansion_2009);
			types.add(New_processElementTypes.Conclusion_2010);
			types.add(New_processElementTypes.Globals_2011);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSource(IAdaptable source) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof AsyncActivityEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.AsyncActivityActor_4001);
			return types;
		}
		if (sourceEditPart instanceof RootEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.RootTerm_4002);
			return types;
		}
		if (sourceEditPart instanceof ConditionTermEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.ConditionTermConditionProxy_4004);
			return types;
		}
		if (sourceEditPart instanceof ConclusionEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.ConclusionConclusionProxy_4005);
			return types;
		}
		if (sourceEditPart instanceof ExpansionEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.ExpansionExpansionProxy_4006);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnTarget(IAdaptable target) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ActorEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.AsyncActivityActor_4001);
			return types;
		}
		if (targetEditPart instanceof ConditionProxyEditPart) {
			List types = new ArrayList();
			types.add(New_processElementTypes.ConditionTermConditionProxy_4004);
			types.add(New_processElementTypes.ConclusionConclusionProxy_4005);
			types.add(New_processElementTypes.ExpansionExpansionProxy_4006);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSourceAndTarget(IAdaptable source,
			IAdaptable target) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof AsyncActivityEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof ActorEditPart) {
				types.add(New_processElementTypes.AsyncActivityActor_4001);
			}
			return types;
		}
		if (sourceEditPart instanceof RootEditPart) {
			List types = new ArrayList();
			return types;
		}
		if (sourceEditPart instanceof ConditionTermEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof ConditionProxyEditPart) {
				types
						.add(New_processElementTypes.ConditionTermConditionProxy_4004);
			}
			return types;
		}
		if (sourceEditPart instanceof ConclusionEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof ConditionProxyEditPart) {
				types
						.add(New_processElementTypes.ConclusionConclusionProxy_4005);
			}
			return types;
		}
		if (sourceEditPart instanceof ExpansionEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof ConditionProxyEditPart) {
				types.add(New_processElementTypes.ExpansionExpansionProxy_4006);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForSource(IAdaptable target,
			IElementType relationshipType) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ActorEditPart) {
			List types = new ArrayList();
			if (relationshipType == New_processElementTypes.AsyncActivityActor_4001) {
				types.add(New_processElementTypes.AsyncActivity_2003);
			}
			return types;
		}
		if (targetEditPart instanceof ConditionProxyEditPart) {
			List types = new ArrayList();
			if (relationshipType == New_processElementTypes.ConditionTermConditionProxy_4004) {
				types.add(New_processElementTypes.ConditionTerm_3005);
			}
			if (relationshipType == New_processElementTypes.ConclusionConclusionProxy_4005) {
				types.add(New_processElementTypes.Conclusion_2010);
			}
			if (relationshipType == New_processElementTypes.ExpansionExpansionProxy_4006) {
				types.add(New_processElementTypes.Expansion_2009);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForTarget(IAdaptable source,
			IElementType relationshipType) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof AsyncActivityEditPart) {
			List types = new ArrayList();
			if (relationshipType == New_processElementTypes.AsyncActivityActor_4001) {
				types.add(New_processElementTypes.Actor_2007);
			}
			return types;
		}
		if (sourceEditPart instanceof RootEditPart) {
			List types = new ArrayList();
			return types;
		}
		if (sourceEditPart instanceof ConditionTermEditPart) {
			List types = new ArrayList();
			if (relationshipType == New_processElementTypes.ConditionTermConditionProxy_4004) {
				types.add(New_processElementTypes.ConditionProxy_2006);
			}
			return types;
		}
		if (sourceEditPart instanceof ConclusionEditPart) {
			List types = new ArrayList();
			if (relationshipType == New_processElementTypes.ConclusionConclusionProxy_4005) {
				types.add(New_processElementTypes.ConditionProxy_2006);
			}
			return types;
		}
		if (sourceEditPart instanceof ExpansionEditPart) {
			List types = new ArrayList();
			if (relationshipType == New_processElementTypes.ExpansionExpansionProxy_4006) {
				types.add(New_processElementTypes.ConditionProxy_2006);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForSource(IAdaptable target,
			IElementType relationshipType) {
		return selectExistingElement(target, getTypesForSource(target,
				relationshipType));
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForTarget(IAdaptable source,
			IElementType relationshipType) {
		return selectExistingElement(source, getTypesForTarget(source,
				relationshipType));
	}

	/**
	 * @generated
	 */
	protected EObject selectExistingElement(IAdaptable host, Collection types) {
		if (types.isEmpty()) {
			return null;
		}
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart == null) {
			return null;
		}
		Diagram diagram = (Diagram) editPart.getRoot().getContents().getModel();
		Collection elements = new HashSet();
		for (Iterator it = diagram.getElement().eAllContents(); it.hasNext();) {
			EObject element = (EObject) it.next();
			if (isApplicableElement(element, types)) {
				elements.add(element);
			}
		}
		if (elements.isEmpty()) {
			return null;
		}
		return selectElement((EObject[]) elements.toArray(new EObject[elements
				.size()]));
	}

	/**
	 * @generated
	 */
	protected boolean isApplicableElement(EObject element, Collection types) {
		IElementType type = ElementTypeRegistry.getInstance().getElementType(
				element);
		return types.contains(type);
	}

	/**
	 * @generated
	 */
	protected EObject selectElement(EObject[] elements) {
		Shell shell = Display.getCurrent().getActiveShell();
		ILabelProvider labelProvider = new AdapterFactoryLabelProvider(
				New_processDiagramEditorPlugin.getInstance()
						.getItemProvidersAdapterFactory());
		ElementListSelectionDialog dialog = new ElementListSelectionDialog(
				shell, labelProvider);
		dialog.setMessage("Available domain model elements:");
		dialog.setTitle("Select domain model element");
		dialog.setMultipleSelection(false);
		dialog.setElements(elements);
		EObject selected = null;
		if (dialog.open() == Window.OK) {
			selected = (EObject) dialog.getFirstResult();
		}
		return selected;
	}
}
