package newprocess.validation;

import newprocess.Element;

/**
 * @author sh
 *
 */
public class ElementValidatorImpl implements ElementValidator {

	public static final ElementValidatorImpl INSTANCE = new ElementValidatorImpl();
		
	/**
	 * validates the name of the Element
	 * @param act
	 * @return
	 */
	public boolean validateName(Element act) {
		if(act.getName() == null || act.getName() == "") return false;
		return true;
	}
	
	/**
	 * validates the implementation of the Element
	 * @param act
	 * @return
	 */
	public boolean validateImplementation(Element act) {
		if(ImplementationValidator.INSTANCE.validate(act)) return true;
		return false;
	}
}
