package model;



import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.openarchitectureware.workflow.lib.WorkflowComponentWithModelSlot;

@SuppressWarnings("unchecked")
public abstract class AbstractEmfWorkflowComponent extends
		WorkflowComponentWithModelSlot {

	static {
		new StandaloneSetup();
	}

	public void setUseSingleGlobalResourceSet( boolean b ) {
		if (b)
			resourceSet = SingleGlobalResourceSet.get();
	}
	
	protected ResourceSet resourceSet = new ResourceSetImpl();
	
	protected String uri;

	public void setResourceSet(ResourceSet resourceSet) {
		this.resourceSet = resourceSet;
	}

	public void setUri(String uri) {
		this.uri = uri;
	}
	
	public ResourceSet getResourceSet() {
		return resourceSet;
	}
	
	public String getUri() {
		return uri;
	}
}
