package org.concern;

/**
 * A persister is a loader, that is able to store changes on a subject.
 * @version $Revision: 496 $
 */
public interface Persister<S>
    extends Loader<S>
{
    void update(S subject) throws PersisterException;
    String save(S subject) throws PersisterException;
}
