package org.concern.controller;

import org.concern.LoaderException;
import org.concern.Log;
import org.concern.SubjectNotFoundException;
import org.concern.UnknownSubjectException;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public abstract class AbstractNode
    implements Node
{
    protected org.concern.controller.Controller controller;
    protected Map environment = new HashMap();

    public void setController(Controller controller) {
        this.controller = controller;
    }

    protected final String getProcessName() {
        return controller.getProcessName();
    }

    public void setEnvironment(Map environment) {
        this.environment = environment;
    }

    protected Map getEnvironment() {
        return environment;
    }

    public String toString() {
        return getName();
    }
}
