package org.concern.controller.jmx;

import java.lang.reflect.*;
import java.io.Serializable;

class CollaborationProxy
    implements InvocationHandler, Serializable
{
    private String name;

    public CollaborationProxy(String name) {
        this.name = name;
    }

    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
       try {
          return method.invoke(CollaborationService.getCollaboration(name), args);
       }
       catch (InvocationTargetException e) {
           throw e.getTargetException();
       }
       catch (Throwable e) {
           e.printStackTrace();
           throw e;
       }
    }
}
