package org.concern.controller.jmx;

import org.concern.Collaboration;
import org.concern.ControllerException;

/**
 * @see org.concern.controller.jmx.ControllerService
 * @author hengels
 */
public interface CollaborationServiceMBean
    extends Collaboration
{
    /**
     * Create the <tt>Collaboration</tt> and bind it to the jndi name
     */
    public void start() throws ControllerException;
    /**
     * Unbind the <tt>Collaboration</tt> or stub from jndi
     */
    public void stop();

    String getJndiName();

    void setJndiName(String jndiName);
}
