package org.concern.model;

import javax.swing.JPanel;

public abstract class AbstractCustomEditor extends JPanel {
	
	private Element element;

	public AbstractCustomEditor() {
		super();
	}
	
	public abstract void init();
	
	public abstract void load();
	
	public abstract void save();
	
	public abstract void cancel();

	public Element getElement() {
		return element;
	}

	public void setElement(Element element) {
		this.element = element;
	}
	
}
