/*
 * $Id: NotOperator.java 265 2004-04-15 13:08:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model.parser.ast;



/**
 * @version $Revision: 265 $
 */
public class NotOperator extends AbstractNode
{
    public NotOperator(AbstractNode node) {
        super.addChild(node);
    }

    public Object accept(NodeVisitor v) {
        return v.visit(this);
    }
}
