package org.concern.controller;

public class DummySynchronousActivity
    extends AbstractSynchronousActivity
{
    public DummySynchronousActivity() {
    }

    public DummySynchronousActivity(String name) {
        super(name);
        environment.put("activity.precondition", name);
        environment.put("activity.postcondition", "");
        environment.put("activity.reentrant", Boolean.TRUE);
    }

    public void execute(Object subject) throws ActivityExecutionException {
        System.out.println("execute " + getName() + " on " + subject);
    }

    Integer dummy;

    public void setDummy(Integer dummy) {
        this.dummy = dummy;
    }

    public Integer getDummy() {
        return dummy;
    }
}
