/* $Id $ */
package org.conform;

import java.beans.PropertyChangeListener;

/**
 * Data binding interface for a bean.
 */
public interface BeanData
    extends Data
{
    BeanMeta getBeanMeta();
    PropertyData getPropertyData(PropertyMeta propertyMeta);

    Object createInstance();

    void addPropertyChangeListener(PropertyChangeListener listener);
    void removePropertyChangeListener(PropertyChangeListener listener);
    PropertyChangeListener[] getPropertyChangeListeners();

    void addPropertyChangeListener(String propertyName, PropertyChangeListener listener);
    void removePropertyChangeListener(String propertyName, PropertyChangeListener listener);
    PropertyChangeListener[] getPropertyChangeListeners(String propertyName);

    void revalidateAll();
}
