package org.conform;

import java.util.*;
import java.io.Serializable;

public class DefaultPropertySorter
    implements Comparator, Serializable
{
    public static final Comparator INSTANCE = new DefaultPropertySorter();

    public int compare(Object o1, Object o2) {
        PropertyMeta p1 = (PropertyMeta)o1;
        PropertyMeta p2 = (PropertyMeta)o2;
        return p1.getPriority() - p2.getPriority();
    }
}
