package org.conform;

import javax.swing.event.ChangeListener;

/**
 * A DomainProvider, whose choosable values may alter. Apropriate for Many-to-One- Relations and the like.
 */
public interface DynamicDomainProvider
    extends DomainProvider
{
    public void addChangeListener(ChangeListener listener);
    public void removeChangeListener(ChangeListener listener);
    public ChangeListener[] getChangeListeners();

    void refresh();
}
