package org.conform;

public class NewInstanceInitializer
    implements Initializer
{
    Class clazz;

    public NewInstanceInitializer(Class clazz) {
        this.clazz = clazz;
    }

    public Object getValue() {
        try {
            return clazz.newInstance();
        }
        catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public String toString() {
        return "NewInstance: " + clazz.getName();
    }
}
