/* $Id: StaticDomainProvider.java 652 2006-01-19 11:12:50Z hengels $ */
package org.conform;

import java.util.*;

/**
 * @version $Revision: 652 $
 */
public class StaticDomainProvider
    implements DomainProvider
{
    private Object[] enumerationValues;

    public StaticDomainProvider() {
    }

    public StaticDomainProvider(Object[] enumerationValues) {
        this.enumerationValues = enumerationValues;
    }

    public Object[] getEnumerationValues() {
        return enumerationValues;
    }

    public void setEnumerationValues(Object[] enumerationValues) {
        this.enumerationValues = enumerationValues;
    }

    public List getDomain() {
        return getEnumerationValues() != null
            ? Arrays.asList(getEnumerationValues())
            : Collections.EMPTY_LIST;
    }

    public String toString() {
        return "Enumeration: " + (enumerationValues != null ? "" + enumerationValues.length : "-");
    }
}
