package org.conform;

import javax.swing.table.TableModel;
import java.util.*;

/**
 * @author hengels
 * @version $Revision: 753 $
 */
public interface TableData
    extends Data, TableModel
{
    List getRows();

    void setRows(List rows);

    int getRowCount();

    Object newRow();

    void addRow(Object object);

    Object removeRow(int index);

    BeanData getRowData(int rowIndex);

    PropertyData getCellData(int rowIndex, int columnIndex);
    PropertyData getCellData(int rowIndex, String propertyName);

    BeanMeta getBeanMeta();
}
