/* $Id: ValidationListener.java 768 2006-12-05 14:55:00Z hengels $ */
package org.conform;

import java.util.*;

/**
 * A validation listener is informed of all validation state changes. A validation listener can be used to create a
 * validation report.
 * 
 * @version $Revision: 768 $
 */
public interface ValidationListener extends EventListener
{
    void addIssues(ValidationEvent event);
    void removeIssues(ValidationEvent event);
    void clearIssues(Meta meta);
}
