package org.conform.mdl;

import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: nina
 * Date: 23.08.2003
 * Time: 22:55:39
 * To change this template use Options | File Templates.
 */
class MutableExpression extends Expression {
    private Object property;
    private Vector argV = new Vector();

    private String capitalize(String propertyName) {
        if (propertyName.length() == 0) {
            return propertyName;
        }
        return propertyName.substring(0, 1).toUpperCase() + propertyName.substring(1);
    }

    public MutableExpression() {
        super(null, null, null);
    }

    public Object[] getArguments() {
    	return argV.toArray();
    }

    public String getMethodName() {
    	if (property == null) {
            return super.getMethodName();
    	}
        int setterArgs = (property instanceof String) ? 1 : 2;
        String methodName = (argV.size() == setterArgs) ? "set" : "get";
        if (property instanceof String) {
            return methodName + capitalize((String)property);
        }
        else {
            return methodName;
        }
    }

    public void addArg(Object arg) {
    	argV.add(arg);
    }

    public void setTarget(Object target) {
    	this.target = target;
    }

    public void setMethodName(String methodName) {
    	this.methodName = methodName;
    }
    public void setProperty(Object property) {
    	this.property = property;
    }
}
