/* $Id: BeanColumnModel.java 718 2006-10-24 09:19:20Z hengels $ */
package org.conform.wings;

import org.conform.*;
import org.wingx.table.XDefaultTableColumnModel;

import java.util.*;


public class BeanColumnModel
    extends XDefaultTableColumnModel
{
    private BeanMeta beanMeta;

    public BeanColumnModel() {
    }

    public BeanColumnModel(BeanMeta beanMeta) {
        setBeanMeta(beanMeta);
    }

    public BeanMeta getBeanMeta() {
        return beanMeta;
    }

    protected void setBeanMeta(BeanMeta beanMeta) {
        this.beanMeta = beanMeta;

        List columns = (List)getColumns();
        columns.clear();
        columns.addAll(ComponentFactory.INSTANCE.createTableColumns(beanMeta));
    }
}
