package org.conform.wings.devel;

import org.wings.*;
import org.conform.BeanMeta;
import org.conform.wings.devel.MetaViewer;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author hengels
 * @version $Revision: 653 $
 */
public class MetaViewerPopup
    extends SPopupMenu
{
    private SComponent component;

    public MetaViewerPopup() {
    }

    public MetaViewerPopup(SComponent component) {
        this.component = component;
    }

    public SComponent getComponent() {
        return component;
    }

    public void setComponent(SComponent component) {
        this.component = component;
    }

    public void addMeta(BeanMeta beanMeta) {
        add(new SMenuItem(new ViewerAction(beanMeta)));
    }

    class ViewerAction
        extends AbstractAction
    {
        BeanMeta beanMeta;

        public ViewerAction(BeanMeta beanMeta) {
            this.beanMeta = beanMeta;
            putValue(Action.NAME, beanMeta.getName());
        }

        public void actionPerformed(ActionEvent e) {
            SOptionPane.showInputDialog(component, beanMeta.getName(), "Meta", new MetaViewer(beanMeta), new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                }
            });
        }
    }
}
