/* $Id: FormattedListCellRenderer.java 766 2006-12-01 13:04:45Z hengels $ */
package org.conform.wings.editor;

import org.conform.format.Format;
import org.wings.SComponent;
import org.wings.SDefaultListCellRenderer;

/**
 * @author hengels
 */
public class FormattedListCellRenderer
    extends SDefaultListCellRenderer
{
    private Format formatter;

    public FormattedListCellRenderer(Format formatter) {
        this.formatter = formatter;
    }

    public SComponent getListCellRendererComponent(SComponent component, Object object, boolean b, int i) {
        String str = formatter.format(object);
        SComponent comp = super.getListCellRendererComponent(component, str, b, i);
        comp.setToolTipText(str);
        return comp;
    }
}
