package org.osbl.inventory;

import org.osbl.inventory.model.Inventory;
import org.osbl.inventory.model.CostType;
import org.osbl.PersistenceObjectLocator;
import org.hibernate.Hibernate;

public class CostTypeLocator
    extends PersistenceObjectLocator<Inventory>
{
    protected String getPersistenceServiceName() {
        return "InventoryPersistence";
    }

    protected Class getObjectClass() {
        return CostType.class;
    }
}
