package org.osbl.inventory.model;

import org.osbl.identity.model.Identity;
import org.osbl.persistence.model.Concrete;
import org.conform.Property;

public class CostCenter
    extends Concrete<Identity>
{
    @Property (mandatory = "true")
    String key;
    @Property (mandatory = "true")
    String name;

    public CostCenter() {
    }

    public CostCenter(Identity general) {
        super(general);
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
