package org.osbl.inventory.model;

import org.osbl.identity.model.Identity;
import org.osbl.identity.model.Address;
import org.osbl.persistence.model.Concrete;
import org.conform.Property;

import java.util.List;

public class Supplier
    extends Concrete<Identity>
{
    String name;
    Address address;

    public Supplier() {
    }

    public Supplier(Identity general) {
        super(general);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Address getAddress() {
        return address;
    }

    public void setAddress(Address address) {
        this.address = address;
    }
}
