package org.osbl.identity.gui;

import org.osbl.client.wings.form.*;
import org.osbl.client.wings.form.layouter.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.identity.model.Identity;
import org.osbl.identity.model.Address;
import org.conform.BeanMeta;
import org.conform.VariationBeanMetaProvider;
import org.conform.modifier.InlineModifier;

public class AddressForm
    extends GenericObjectForm
{
    public AddressForm() {
    }

    protected Instruction createLayoutInstruction() {
        return new PageSet(
            new Page(Identity.class.getName(),
                new Division(
                    new Column(
                        new Title(Address.class.getName()),
                        new LabelAndEditor(ComponentProvider.ROOT, "street"),
                        new LabelAndEditor(ComponentProvider.ROOT, "postcode"),
                        new LabelAndEditor(ComponentProvider.ROOT, "city")
                    ),
                    new Column(
                    )
                ))
        );
    }

    protected Object getObject(String path) {
        return object;
    }

    protected void setObject(String path, Object object) {
        this.object = object;
    }

    protected BeanMeta createBeanMeta(String path) {
        VariationBeanMetaProvider provider = new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider());
        provider.addModifier(new InlineModifier() {
            protected void configure() {
            }
        });
        return provider.getBeanMeta(Address.class);
    }
}
