package org.osbl.identity.model;

import org.conform.Property;
import org.osbl.persistence.model.Concrete;
import org.osbl.authorization.model.Profile;

import java.util.Locale;
import java.util.List;

public class User
    extends Concrete<Identity>
{
    @Property (mandatory = "true")
    String account;
    char[] password;

    Locale locale;
    private List<Profile> profiles;

    public User() {
    }

    public User(Identity general) {
        super(general);
    }

    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public char[] getPassword() {
        return password;
    }

    public void setPassword(char[] password) {
        this.password = password;
    }

    public Locale getLocale() {
        return locale;
    }

    public void setLocale(Locale locale) {
        this.locale = locale;
    }

    public List<Profile> getProfiles() {
        return profiles;
    }

    public void setProfiles(List<Profile> profiles) {
        this.profiles = profiles;
    }
}
