package org.osbl.issue.process;

import org.concern.controller.AbstractTemporalCondition;
import org.concern.controller.ConditionEvaluationException;

import org.osbl.issue.model.Issue;

import java.util.Date;


public class Due
    extends AbstractTemporalCondition<Issue>
{
    public boolean eval(Issue subject) throws ConditionEvaluationException {
        return subject.getDue().before(new Date());
    }

    public long getAnticipatedTransition(Issue subject) {
        return subject.getDue().getTime();
    }
}
        