package org.osbl.orga.gui;

import org.osbl.client.wings.form.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.persistence.Persistence;
import org.osbl.orga.model.Relationship;
import org.osbl.orga.model.Member;
import org.conform.BeanMeta;
import org.conform.VariationBeanMetaProvider;
import org.conform.modifier.InlineModifier;

public class RelationshipList
    extends GenericObjectList
{
    Persistence persistence;

    protected BeanMeta createBeanMeta() {
        return new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider()).addModifier(new InlineModifier() {
            protected void configure() {
                property("peer").setWritable(false);
                property("peer").setFormat(Client.getInstance().getBeanMetaProvider().getBeanMeta(Member.class).getFormat());
                property("relation").setWritable(false);
            }
        }).getBeanMeta(Relationship.class);
    }

    protected ObjectTableModel createModel(BeanMeta beanMeta) {
        return new GenericObjectTableModel(beanMeta, "relation", "peer");
    }

    public Object getRow(int index) {
        return ((GenericObjectTableModel)getModel()).getRow(index);
    }
}
