package org.osbl.orga.model;

import org.conform.Property;
import org.osbl.identity.model.Identity;
import org.osbl.persistence.model.TreeNodeEntity;

import java.util.*;

public class Group
    extends TreeNodeEntity<Organisation>
{
    @Property (mandatory = "true")
    String name;
    @Property (mandatory = "true")
    Identity identity;
    List<Membership> memberships;

    public Group() {
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Identity getIdentity() {
        return identity;
    }

    public void setIdentity(Identity identity) {
        this.identity = identity;
    }

    public List<Membership> getMemberships() {
        return memberships;
    }

    public void setMemberships(List<Membership> memberships) {
        this.memberships = memberships;
    }

    Map<String, Object> properties;

    public void setProperty(String name, Object value) {
        if (properties == null)
            properties = new HashMap<String, Object>();
        properties.put(name, value);
    }

    public Object getProperty(String name) {
        if (properties == null)
            properties = new HashMap<String, Object>();
        return properties.get(name);
    }

    protected void setProperties(Map<String, Object> properties) {
        this.properties = properties;
    }

    public Map<String, Object> getProperties() {
        return properties;
    }
}
