package org.osbl.orga.model;

import org.osbl.identity.model.Identity;
import org.conform.Property;
import org.osbl.persistence.model.Entity;

import java.util.List;

public class Member
    extends Entity
{
    @Property (mandatory = "true")
    Organisation organisation;
    Identity identity;
    List<Relationship> relationships;

    public Member() {
    }

    public Organisation getOrganisation() {
        return organisation;
    }

    public void setOrganisation(Organisation organisation) {
        this.organisation = organisation;
    }

    public Identity getIdentity() {
        return identity;
    }

    public void setIdentity(Identity identity) {
        this.identity = identity;
    }

    public List<Relationship> getRelationships() {
        return relationships;
    }

    public void setRelationships(List<Relationship> relationships) {
        this.relationships = relationships;
    }
}
