package org.osbl.demo.urlaub.gui;

import org.osbl.client.wings.concern.ObjectFormViewModes;
import org.conform.*;
import org.conform.modifier.InlineModifier;
import org.conform.wings.editor.BooleanEditor;

public class BuchenUrlaubsAntragForm
    extends UrlaubsAntragForm
{
    public BuchenUrlaubsAntragForm() {
        addViewModeVariation(ObjectFormViewModes.ACTIVITY_VIEW, new InlineModifier() {
            protected void configure() {
                property("anlass").setWritable(false);
                property("vonDatum").setWritable(false);
                property("bisDatum").setWritable(false);
                property("vonZeit").setWritable(false);
                property("bisZeit").setWritable(false);
                property("genehmigung").setWritable(false);
                property("gebucht").setWritable(false);
                property("benachrichtigt").setWritable(false);
                property("eingetragen").setWritable(false);
                property("storniert").setWritable(false);

                property("gebucht").setWritable(true);
                property("gebucht").setAttribute(DefaultBeanData.PROPERTY_DATA_CLASS, NowOrNeverPropertyData.class.getName());
                property("gebucht").setAttribute(org.conform.wings.Editor.CUSTOM_EDITOR, new BooleanEditor());
            }
        });
        setViewMode(ObjectFormViewModes.ACTIVITY_VIEW);
    }
}
