package org.osbl.demo.urlaub.gui;

import org.osbl.client.wings.concern.ObjectFormViewModes;
import org.conform.modifier.InlineModifier;
import org.conform.validator.DateRangeValidator;

public class CreateUrlaubsAntragForm
    extends UrlaubsAntragForm
{
    public CreateUrlaubsAntragForm() {
        addViewModeVariation(ObjectFormViewModes.CREATE_VIEW, new InlineModifier() {
            protected void configure() {
                property("anlass").setWritable(false);
                property("vonDatum").setWritable(false);
                property("bisDatum").setWritable(false);
                property("vonZeit").setWritable(false);
                property("bisZeit").setWritable(false);
                property("genehmigung").setWritable(false);
                property("gebucht").setWritable(false);
                property("benachrichtigt").setWritable(false);
                property("eingetragen").setWritable(false);
                property("storniert").setWritable(false);

                property("typ").setWritable(true);
                property("vonDatum").addValidator(new DateRangeValidator(DateRangeValidator.today(), true, null, true));
            }
        });
        setViewMode(ObjectFormViewModes.CREATE_VIEW);
    }
}
