package org.osbl.demo.urlaub.gui;

import org.conform.modifier.InlineModifier;
import org.osbl.client.wings.concern.ObjectFormViewModes;

public class GenehmigenUrlaubsAntragForm
    extends UrlaubsAntragForm
{
    public GenehmigenUrlaubsAntragForm() {
        addViewModeVariation(ObjectFormViewModes.ACTIVITY_VIEW, new InlineModifier() {
            protected void configure() {
                property("anlass").setWritable(false);
                property("vonDatum").setWritable(false);
                property("bisDatum").setWritable(false);
                property("vonZeit").setWritable(false);
                property("bisZeit").setWritable(false);
                property("genehmigung").setWritable(false);
                property("gebucht").setWritable(false);
                property("benachrichtigt").setWritable(false);
                property("eingetragen").setWritable(false);
                property("storniert").setWritable(false);

                property("genehmigung").setWritable(true);
            }
        });
        setViewMode(ObjectFormViewModes.ACTIVITY_VIEW);
    }
}
