/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.demo.urlaub.process;


import org.osbl.demo.urlaub.model.UrlaubsAntrag;
import org.osbl.demo.urlaub.service.GroupWare;
import org.concern.controller.AbstractSynchronousActivity;
import org.concern.controller.ActivityExecutionException;

import java.sql.Timestamp;


public class Eintragen
    extends AbstractSynchronousActivity<UrlaubsAntrag>
{
    GroupWare groupWare;

    public void setGroupWare(GroupWare groupWare) {
        this.groupWare = groupWare;
    }

    public void execute(UrlaubsAntrag subject) throws ActivityExecutionException {
    	 /*PROTECTED REGION ID(org.osbl.demo.urlaub.process.Eintragen.execute) ENABLED START*/
        groupWare.addEvent(0, subject.getCreatedBy(), subject.getVonDatum(), subject.getBisDatum());
        subject.setEingetragen(new Timestamp(System.currentTimeMillis()));
        /*PROTECTED REGION END*/
    }
}
