package org.osbl.concern;

import org.osbl.Module;
import org.osbl.ObjectLocators;
import org.concern.model.Process;
import org.concern.Subject;
import org.concern.Work;

public class ConcernModule
    implements Module
{
    ObjectLocators objectLocators;

    public void setObjectLocators(ObjectLocators objectLocators) {
        this.objectLocators = objectLocators;
    }

    public void initialize() {
        objectLocators.registerObjectLocator(Process.class, new ProcessLocator());
        objectLocators.registerObjectLocator(Subject.class, new SubjectLocator());
        objectLocators.registerObjectLocator(Work.class, new TaskLocator());
    }
}
