package org.osbl.agent.gui.action;

import org.osbl.agent.model.action.SetCurrentTimeAction;


/**
 * The class SetCurrentTimeActionController models the SetCurrentTimeAction.
 * It offers no UI parameters as none is needed.
 * 
 * @author Sebastian Nozzi.
 */
public class SetCurrentTimeActionController extends SetValueActionController {

	/**
	 * Instantiates a new set current time action controller.
	 */
	public SetCurrentTimeActionController() {
		super();
		
		// "now" will be a pre-defined variable in the Ognl evaluation context
		// when the Action is run... context variables are accessed with "#"
		inputField.setText("#"+SetCurrentTimeAction.predefinedNow);
	}

}
