package org.osbl.authorization;

import java.util.*;

public abstract class PermissionCache
{
    protected static PermissionCache INSTANCE;

    public static PermissionCache getInstance() {
        return INSTANCE;
    }

    protected PermissionCache() {
    }

    protected Map<String, SortedSet<String>> permissionsByAction = new HashMap<String, SortedSet<String>>();

    public abstract Map<String, SortedSet<String>> getPermissionsByAction();
}
