package org.osbl.client.web.spring;

import org.osbl.client.web.WebModule;
import org.springframework.beans.factory.InitializingBean;
import org.apache.commons.logging.LogFactory;

public abstract class SpringWebModule
    implements WebModule, InitializingBean
{
    private static org.apache.commons.logging.Log LOG = LogFactory.getLog(SpringWebModule.class);

    public void afterPropertiesSet() throws Exception {
        LOG.info("Initializing WebModule " + getClass().getSimpleName());
        initialize();
    }
}
