package org.osbl.client.wings;

import org.wings.*;
import org.wings.border.SAbstractBorder;
import org.wings.border.SLineBorder;

import java.awt.*;

/**
 * A underlined label with style "formtitle", that spans the full width
 */
public class XTitleLabel
    extends SLabel
{
    public XTitleLabel(String text) {
        super(text);
        setStyle("SLabel formtitle");
        setPreferredSize(SDimension.FULLWIDTH);
        SAbstractBorder titleBorder = new SLineBorder(Color.ORANGE, 0);
        titleBorder.setThickness(2, SConstants.BOTTOM);
        titleBorder.setInsets(new Insets(0, 0, 2, 0));
        setBorder(titleBorder);
    }
}
