/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.client.wings.action;

import org.osbl.client.wings.XIcons;
import org.osbl.client.wings.action.NavigationAction;
import org.wings.session.SessionManager;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.util.Map;

/**
 * @author hengels
 * @version $Revision: 1020 $
 */
public class LogoutAction
    extends NavigationAction
{
    public LogoutAction(String command) {
        putValue(Action.ACTION_COMMAND_KEY, command);
        putValue(Action.SMALL_ICON, XIcons.EXIT);
    }

    public void actionPerformed(ActionEvent e) {
        SessionManager.getSession().exit();
    }

    public void navigate(Object object)  {
        actionPerformed(new ActionEvent(this, -1, toString()));
    }

    public void navigate(Map<String,String> query) {
        actionPerformed(new ActionEvent(this, -1, toString()));
    }

    public void setEnabled(boolean newValue) {
    }
}
