package org.osbl.client.wings.concern;

import org.osbl.client.wings.shell.Client;
import org.osbl.client.wings.form.GenericObjectList;
import org.osbl.client.wings.form.ObjectTableModel;
import org.conform.BeanMeta;
import org.concern.model.Process;

public class ProcessList
    extends GenericObjectList
{
    protected BeanMeta createBeanMeta() {
        return Client.getInstance().getBeanMetaProvider().getBeanMeta(Process.class);
    }

    protected ObjectTableModel createModel(BeanMeta beanMeta) {
        return new ProcessTableModel(beanMeta);
    }

    public Object getRow(int index) {	// was protected
        return ((ProcessTableModel)model).getRow(index);
    }

    protected Object idOf(Object object) {
        return ((Process)object).getName();
    }
}
