package org.osbl.client.wings.control;

import org.osbl.client.wings.shell.Tool;
import org.concern.Controller;
import org.concern.Subject;
import org.wings.SDimension;
import org.wings.SListSelectionModel;
import org.wingx.XScrollPane;
import org.wingx.XTable;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
class EnlistmentsTable
    extends XScrollPane
    implements Plugin
{
    XTable table;
    EnlistmentsTableModel enlistmentsModel;

    public EnlistmentsTable() {
        enlistmentsModel = new EnlistmentsTableModel();
        table = new XTable(enlistmentsModel);
        table.setEditable(false);
        table.setPreferredSize(SDimension.FULLWIDTH);
        table.setSelectionMode(SListSelectionModel.NO_SELECTION);
        setViewportView(table);
    }

    public void update() {
        enlistmentsModel.refresh();
    }

    public void setController(Controller controller) {
        enlistmentsModel.setController(controller);
    }

    public void setSubject(Subject subject) {
        enlistmentsModel.setSubject(subject);
    }

    public List<Tool> getTools() {
        return Collections.EMPTY_LIST;
    }
}
