package org.osbl.client.wings.devtools;

import org.wings.*;
import org.osbl.client.wings.shell.Client;

import javax.swing.*;


import java.awt.event.ActionEvent;

/**
 * TODO: document me!!!
 * <p/>
 * <code>ContainerColoringDevTool</code>.
 * User: rro
 * Date: 31.07.2006
 * Time: 13:58:21
 *
 * @author Roman R&auml;dle
 * @version $Revision$
 */
public class DumpClassNamesDevTool extends AbstractAction {

    DumpClassNamesDevTool.ColoringTreeWalker treeWalker = new DumpClassNamesDevTool.ColoringTreeWalker();

    /**
     * Defines an <code>Action</code> object with a default
     * description string and default icon.
     */
    public DumpClassNamesDevTool() {
        putValue(Action.NAME, "Classnames");
        putValue(Action.SHORT_DESCRIPTION, "Dump class names to System.out");
    }

    /**
     * Invoked when an action occurs.
     */
    public void actionPerformed(ActionEvent e) {
        SComponent content = Client.getInstance().getShownComponent();
        treeWalker.walk(content);
    }

    class ColoringTreeWalker implements ComponentTreeWalker {

        public boolean walk(SComponent c) {
            walk(c, "");
            return false;
        }

        public boolean walk(SComponent c, String indent) {
            System.out.println(indent + c.getClass().getName() + " " + c.getName());

            indent += "   ";
            if (c instanceof SContainer) {
                SContainer container = (SContainer) c;

                if (container.getComponentCount() > 0) {
                    for (SComponent child : container.getComponents()) {
                        walk(child, indent);
                    }
                }
            }
            return false;
        }
    }
}
