package org.osbl.client.wings.devtools;

import org.conform.BeanMeta;
import org.osbl.client.wings.XOptionPane;
import org.osbl.client.wings.shell.Client;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class MetaViewerDevTool
    extends AbstractAction
{
    private BeanMeta beanMeta;

    public MetaViewerDevTool(BeanMeta beanMeta) {
        this.beanMeta = beanMeta;
        putValue(Action.NAME, "Meta of " + beanMeta.getType().getSimpleName());
        //putValue(Action.SMALL_ICON, XIcons.REPLACE);
    }

    public void actionPerformed(ActionEvent e) {
        XOptionPane.showInputDialog(
            Client.getInstance().getShownComponent(),
            beanMeta.getName(), "" + getValue(Action.NAME),
            new org.conform.wings.devel.MetaViewer(beanMeta),
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                }
            });
    }
}
