package org.osbl.client.wings.form.editor;

import org.conform.wings.Editor;
import org.conform.PropertyData;
import org.conform.PropertyMeta;
import org.wings.SComponent;

import javax.swing.*;

public abstract class AbstractEditorAction
    extends AbstractAction
    implements EditorAction
{
    private SComponent component;
    PropertyData propertyData;

    public SComponent getComponent() {
        return component;
    }

    public void setComponent(SComponent component) {
        this.component = component;
    }

    public PropertyData getPropertyData() {
        return propertyData;
    }

    public void setPropertyData(PropertyData propertyData) {
        this.propertyData = propertyData;
    }

    public PropertyMeta getPropertyMeta() {
        return getPropertyData().getPropertyMeta();
    }
}
