package org.osbl.client.wings.form.layouter;

import org.wings.*;
import org.osbl.client.wings.form.ComponentProvider;

public class InlineLayouter extends AbstractLayouter {
    SContainer container;
    Page page;

    public InlineLayouter(SContainer container, Page page) {
        this.container = container;
        this.page = page;
    }

    public SContainer build(final ComponentProvider componentProvider) {
        container.setLayout(new SGridBagLayout());
        container.setVerticalAlignment(SConstants.TOP_ALIGN);
        page.build(componentProvider, container);
        collectComponents(container);
        return container;
    }

    protected void setApplicability(Page page, SComponent component, boolean applicable) {
    }

    protected void setApplicability(Division division, SComponent component, boolean applicable) {
    }
}
