package org.osbl.client.wings.form.layouter;

import org.wings.SComponent;

import java.util.EventObject;
import java.util.List;

public class VisibilityEvent
    extends EventObject
{
    List<SComponent> visibles;
    List<SComponent> invisibles;

    public VisibilityEvent(Object source, List<SComponent> visibles, List<SComponent> invisibles) {
        super(source);
        this.visibles = visibles;
        this.invisibles = invisibles;
    }

    public List<SComponent> getVisibles() {
        return visibles;
    }

    public List<SComponent> getInvisibles() {
        return invisibles;
    }
}
