package org.osbl.item;

import org.osbl.ItemCollector;

/**
 * Created by IntelliJ IDEA.
 * User: hengels
 * Date: Nov 8, 2006
 * Time: 12:10:32 PM
 * To change this template use File | Settings | File Templates.
 */
public abstract class AbstractItemCollector
    implements ItemCollector
{
    public void refresh() {
    }

    protected String build(StringBuilder builder, String... parts) {
        int length = builder.length();
        for (String part : parts)
            builder.append(part);

        String item = builder.toString();
        builder.setLength(length);
        return item;
    }
}
