package org.osbl.persistence;

import java.util.List;

public abstract class QueryCommand<T>
    implements Command
{
    protected Class<T> type;

    public QueryCommand<T> setType(Class<T> type) {
        this.type = type;
        return this;
    }

    public abstract List<T> execute();
}
