package org.osbl.persistence;


public abstract class SaveOrUpdateCommand<T>
    implements Command
{
    protected T object;

    public SaveOrUpdateCommand setObject(T object) {
        this.object = object;
        return this;
    }

    public abstract void execute();
}
