package org.osbl.persistence.hibernate;

import org.osbl.persistence.LoadCommand;
import org.osbl.persistence.DeleteCommand;
import org.hibernate.SessionFactory;
import org.hibernate.Session;

public class HibernateDeleteCommand<T>
    extends DeleteCommand<T>
    implements HibernateCommand
{
    SessionFactory sessionFactory;

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    public void execute() {
        Session session = sessionFactory.getCurrentSession();
        session.delete(object);
    }
}
