package org.osbl.persistence.hibernate;

import org.osbl.persistence.LoadCommand;
import org.osbl.persistence.RevertCommand;
import org.hibernate.*;

public class HibernateRevertCommand<T>
    extends RevertCommand
    implements HibernateCommand
{
    SessionFactory sessionFactory;

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    public void execute() {
        Session session = sessionFactory.getCurrentSession();
        session.refresh(object);
        Hibernate.initialize(object);
    }
}
