package org.osbl.persistence.hibernate;

import org.osbl.persistence.LoadCommand;
import org.osbl.persistence.SaveOrUpdateCommand;
import org.hibernate.SessionFactory;
import org.hibernate.Session;


public class HibernateSaveOrUpdateCommand<T>
    extends SaveOrUpdateCommand
    implements HibernateCommand
{
    SessionFactory sessionFactory;

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    public void execute() {
        Session session = sessionFactory.getCurrentSession();
        session.saveOrUpdate(object);
    }
}
