package org.osbl.persistence.model;

import org.conform.Property;

public class TreeNodeEntity<T>
    extends Entity
{
    @Property (mandatory = "true")
    T tree;

    @Property (mandatory = "true")
    String path;
    int depth;

    public T getTree() {
        return tree;
    }

    public void setTree(T tree) {
        this.tree = tree;
    }

    public String getPath() {
        return path;
    }

    public void setPath(String path) {
        this.path = path;
    }

    public int getDepth() {
        return depth;
    }

    public void setDepth(int depth) {
        this.depth = depth;
    }
}
