package org.osbl.spring;

import org.springframework.context.support.ReloadableResourceBundleMessageSource;

import java.util.*;

public class SpringMessageSource
    extends ReloadableResourceBundleMessageSource
{
    public void setBasenames(String string) {
        StringTokenizer stringTokenizer = new StringTokenizer(string);
        String[] basenames = new String[stringTokenizer.countTokens()];
        int i=0;

        while (stringTokenizer.hasMoreTokens())
            basenames[i++] = stringTokenizer.nextToken();

        super.setBasenames(basenames);
    }
}
