package org.osbl.riskmanagement.gui;

import org.osbl.client.wings.concern.ObjectFormViewModes;
import org.conform.modifier.InlineModifier;

public class CareRiskForm
    extends RiskForm
{
    public CareRiskForm() {
        addViewModeVariation(ObjectFormViewModes.ACTIVITY_VIEW, new InlineModifier() {
            protected void configure() {
                property("type").setWritable(false);
                property("coverage").setWritable(false);
                property("amount").setWritable(false);
                property("probability").setWritable(false);
                property("comment").setWritable(false);
                property("assignee").setWritable(false);
                property("criticality").setWritable(false);
                property("progression").setWritable(false);
                property("obsolete").setWritable(false);

                property("coverage").setWritable(true);
                property("amount").setWritable(true);
                property("probability").setWritable(true);
                property("comment").setWritable(true);

                property("coverage").setMandatory(true);
                property("amount").setMandatory(true);
                property("probability").setMandatory(true);
            }
        });
        setViewMode(ObjectFormViewModes.ACTIVITY_VIEW);
    }
}
