package org.osbl.riskmanagement.gui;

import org.osbl.client.wings.XIcons;
import org.osbl.riskmanagement.model.Criticality;
import org.wings.SIcon;
import org.wings.SURLIcon;

import java.util.Map;
import java.util.HashMap;

public class RiskManagementIcons
    extends XIcons
{
    public static final SIcon RISKTYPE       = new SURLIcon("../icon/16x16/risktype.png", 16, 16);
    public static final SIcon CLASSIFICATION = new SURLIcon("../icon/16x16/organisation.png", 16, 16);

    public static final SIcon LIGHT_OFF = new SURLIcon("../icon/16x16/light_off.png", 16, 16);
    public static final SIcon LIGHT_GREEN = new SURLIcon("../icon/16x16/light_green.png", 16, 16);
    public static final SIcon LIGHT_YELLOW = new SURLIcon("../icon/16x16/light_yellow.png", 16, 16);
    public static final SIcon LIGHT_ORANGE = new SURLIcon("../icon/16x16/light_orange.png", 16, 16);
    public static final SIcon LIGHT_RED = new SURLIcon("../icon/16x16/light_red.png", 16, 16);

    public static final Map<Object, SIcon> ICONS = new HashMap<Object, SIcon>(4);
    static {
        ICONS.put(Criticality.UNKNOWN, LIGHT_OFF);
        ICONS.put(Criticality.LOW, LIGHT_GREEN);
        ICONS.put(Criticality.MEDIUM, LIGHT_YELLOW);
        ICONS.put(Criticality.HIGH, LIGHT_ORANGE);
        ICONS.put(Criticality.CRITICAL, LIGHT_RED);
    }
}
