package org.osbl.riskmanagement.gui.report;

import org.osbl.client.wings.XTabbedPane;
import org.osbl.client.wings.form.DelegateEnvironment;
import org.osbl.client.wings.shell.Application;
import org.osbl.client.wings.shell.Environment;
import org.osbl.riskmanagement.model.*;
import org.wings.*;

public class RiskReport
    extends XTabbedPane
    implements Application
{
    protected Environment environment = new DelegateEnvironment(true);

    public RiskReport() {
        setPreferredSize(SDimension.FULLAREA);
        addTab(Risk.class.getName() + ".tree", new RiskTreeTable());
        addTab(Risk.class.getName() + ".chart", new RiskChart());

        environment.setContentPane(this);
        environment.setTitle("org.osbl.riskmanagement.actions.report");
    }

    public Environment getEnvironment() {
        return environment;
    }
}
