/**
 * 
 */
package newprocess.diagram.cust.layouter;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gmf.runtime.diagram.ui.figures.BorderedNodeFigure;

/**
 * @author sh
 *
 */
public class ConditionStackLayout extends StackLayout {
	
	public void layout(IFigure figure) {		
		if(figure instanceof Figure) {
			Figure fig = (Figure)figure;
			if(fig.getChildren().isEmpty()) {
				super.layout(figure);
				return;
			}
			
			Object fig2 = fig.getChildren().get(0);
			if(fig2 instanceof BorderedNodeFigure) {
				BorderedNodeFigure fig3 = (BorderedNodeFigure)fig2;
				Rectangle condRect = fig.getClientArea();

				// regard the height of the port figure
				int y = condRect.y + 5;
				// lower the height because of the port on top and on bottom
				int height = condRect.height-10;
									
				Rectangle newRect = new Rectangle(condRect.x,y,condRect.width,height);
				fig3.setBounds(newRect);
			}
			else super.layout(figure);
		}
		else super.layout(figure);
	}
}
