package newprocess.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.ActorNameEditPart;
import newprocess.diagram.edit.parts.AndOperatorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartment2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartment2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.AsyncActivityName2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityNameEditPart;
import newprocess.diagram.edit.parts.ConclusionConclusionPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ConclusionEditPart;
import newprocess.diagram.edit.parts.ConclusionNameEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.ConditionNameEditPart;
import newprocess.diagram.edit.parts.ConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionProxyProxyNameEditPart;
import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.EventEventPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.EventNameEditPart;
import newprocess.diagram.edit.parts.ExpansionEditPart;
import newprocess.diagram.edit.parts.ExpansionExpansionPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ExpansionNameEditPart;
import newprocess.diagram.edit.parts.Expression2EditPart;
import newprocess.diagram.edit.parts.Expression3EditPart;
import newprocess.diagram.edit.parts.Expression4EditPart;
import newprocess.diagram.edit.parts.Expression5EditPart;
import newprocess.diagram.edit.parts.Expression6EditPart;
import newprocess.diagram.edit.parts.Expression7EditPart;
import newprocess.diagram.edit.parts.Expression8EditPart;
import newprocess.diagram.edit.parts.ExpressionEditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment2EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment3EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment4EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment5EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment6EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment7EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment8EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartmentEditPart;
import newprocess.diagram.edit.parts.GlobalsEditPart;
import newprocess.diagram.edit.parts.GlobalsGlobalsConditionCompartmentEditPart;
import newprocess.diagram.edit.parts.GlobalsGlobalsLoaderCompartmentEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.ListenerListenerPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ListenerNameEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.LoaderNameEditPart;
import newprocess.diagram.edit.parts.MessageEditPart;
import newprocess.diagram.edit.parts.MessageNameEditPart;
import newprocess.diagram.edit.parts.OrOperatorEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.RootEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;
import newprocess.diagram.edit.parts.SyncActivityNameEditPart;
import newprocess.diagram.edit.parts.SyncActivitySynActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.SyncActivitySynActivityPreconditionCompartmentEditPart;

import newprocess.diagram.part.New_processVisualIDRegistry;

import newprocess.diagram.view.factories.ActorNameViewFactory;
import newprocess.diagram.view.factories.ActorViewFactory;
import newprocess.diagram.view.factories.AndOperatorViewFactory;
import newprocess.diagram.view.factories.AsyncActivity2ViewFactory;
import newprocess.diagram.view.factories.AsyncActivityActorViewFactory;
import newprocess.diagram.view.factories.AsyncActivityAsyncActivityPostconditionCompartment2ViewFactory;
import newprocess.diagram.view.factories.AsyncActivityAsyncActivityPostconditionCompartmentViewFactory;
import newprocess.diagram.view.factories.AsyncActivityAsyncActivityPreconditionCompartment2ViewFactory;
import newprocess.diagram.view.factories.AsyncActivityAsyncActivityPreconditionCompartmentViewFactory;
import newprocess.diagram.view.factories.AsyncActivityName2ViewFactory;
import newprocess.diagram.view.factories.AsyncActivityNameViewFactory;
import newprocess.diagram.view.factories.AsyncActivityViewFactory;
import newprocess.diagram.view.factories.ConclusionConclusionPostconditionCompartmentViewFactory;
import newprocess.diagram.view.factories.ConclusionConclusionProxyViewFactory;
import newprocess.diagram.view.factories.ConclusionNameViewFactory;
import newprocess.diagram.view.factories.ConclusionViewFactory;
import newprocess.diagram.view.factories.ConditionNameViewFactory;
import newprocess.diagram.view.factories.ConditionProxyProxyNameViewFactory;
import newprocess.diagram.view.factories.ConditionProxyViewFactory;
import newprocess.diagram.view.factories.ConditionTermConditionProxyViewFactory;
import newprocess.diagram.view.factories.ConditionTermViewFactory;
import newprocess.diagram.view.factories.ConditionViewFactory;
import newprocess.diagram.view.factories.EventEventPostconditionCompartmentViewFactory;
import newprocess.diagram.view.factories.EventNameViewFactory;
import newprocess.diagram.view.factories.EventViewFactory;
import newprocess.diagram.view.factories.ExpansionExpansionPostconditionCompartmentViewFactory;
import newprocess.diagram.view.factories.ExpansionExpansionProxyViewFactory;
import newprocess.diagram.view.factories.ExpansionNameViewFactory;
import newprocess.diagram.view.factories.ExpansionViewFactory;
import newprocess.diagram.view.factories.Expression2ViewFactory;
import newprocess.diagram.view.factories.Expression3ViewFactory;
import newprocess.diagram.view.factories.Expression4ViewFactory;
import newprocess.diagram.view.factories.Expression5ViewFactory;
import newprocess.diagram.view.factories.Expression6ViewFactory;
import newprocess.diagram.view.factories.Expression7ViewFactory;
import newprocess.diagram.view.factories.Expression8ViewFactory;
import newprocess.diagram.view.factories.ExpressionExpressionCompartment2ViewFactory;
import newprocess.diagram.view.factories.ExpressionExpressionCompartment3ViewFactory;
import newprocess.diagram.view.factories.ExpressionExpressionCompartment4ViewFactory;
import newprocess.diagram.view.factories.ExpressionExpressionCompartment5ViewFactory;
import newprocess.diagram.view.factories.ExpressionExpressionCompartment6ViewFactory;
import newprocess.diagram.view.factories.ExpressionExpressionCompartment7ViewFactory;
import newprocess.diagram.view.factories.ExpressionExpressionCompartment8ViewFactory;
import newprocess.diagram.view.factories.ExpressionExpressionCompartmentViewFactory;
import newprocess.diagram.view.factories.ExpressionViewFactory;
import newprocess.diagram.view.factories.GlobalsGlobalsConditionCompartmentViewFactory;
import newprocess.diagram.view.factories.GlobalsGlobalsLoaderCompartmentViewFactory;
import newprocess.diagram.view.factories.GlobalsViewFactory;
import newprocess.diagram.view.factories.ListenerListenerPreconditionCompartmentViewFactory;
import newprocess.diagram.view.factories.ListenerNameViewFactory;
import newprocess.diagram.view.factories.ListenerViewFactory;
import newprocess.diagram.view.factories.LoaderNameViewFactory;
import newprocess.diagram.view.factories.LoaderViewFactory;
import newprocess.diagram.view.factories.MessageNameViewFactory;
import newprocess.diagram.view.factories.MessageViewFactory;
import newprocess.diagram.view.factories.OperatorTermSubTermViewFactory;
import newprocess.diagram.view.factories.OrOperatorViewFactory;
import newprocess.diagram.view.factories.ProcessViewFactory;
import newprocess.diagram.view.factories.RootTermViewFactory;
import newprocess.diagram.view.factories.RootViewFactory;
import newprocess.diagram.view.factories.SyncActivityNameViewFactory;
import newprocess.diagram.view.factories.SyncActivitySynActivityPostconditionCompartmentViewFactory;
import newprocess.diagram.view.factories.SyncActivitySynActivityPreconditionCompartmentViewFactory;
import newprocess.diagram.view.factories.SyncActivityViewFactory;

/**
 * @generated
 */
public class New_processViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter,
			String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (ProcessEditPart.MODEL_ID.equals(diagramKind)
				&& New_processVisualIDRegistry
						.getDiagramVisualID(semanticElement) != -1) {
			return ProcessViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (elementType != null
				&& !New_processElementTypes.isKnownElementType(elementType)) {
			return null;
		}
		EClass semanticType = getSemanticEClass(semanticAdapter);
		EObject semanticElement = getSemanticElement(semanticAdapter);
		int nodeVID = New_processVisualIDRegistry.getNodeVisualID(
				containerView, semanticElement, semanticType, semanticHint);
		switch (nodeVID) {
		case SyncActivityEditPart.VISUAL_ID:
			return SyncActivityViewFactory.class;
		case SyncActivityNameEditPart.VISUAL_ID:
			return SyncActivityNameViewFactory.class;
		case ListenerEditPart.VISUAL_ID:
			return ListenerViewFactory.class;
		case ListenerNameEditPart.VISUAL_ID:
			return ListenerNameViewFactory.class;
		case AsyncActivityEditPart.VISUAL_ID:
			return AsyncActivityViewFactory.class;
		case AsyncActivityNameEditPart.VISUAL_ID:
			return AsyncActivityNameViewFactory.class;
		case EventEditPart.VISUAL_ID:
			return EventViewFactory.class;
		case EventNameEditPart.VISUAL_ID:
			return EventNameViewFactory.class;
		case ConditionProxyEditPart.VISUAL_ID:
			return ConditionProxyViewFactory.class;
		case ConditionProxyProxyNameEditPart.VISUAL_ID:
			return ConditionProxyProxyNameViewFactory.class;
		case ActorEditPart.VISUAL_ID:
			return ActorViewFactory.class;
		case ActorNameEditPart.VISUAL_ID:
			return ActorNameViewFactory.class;
		case MessageEditPart.VISUAL_ID:
			return MessageViewFactory.class;
		case MessageNameEditPart.VISUAL_ID:
			return MessageNameViewFactory.class;
		case ExpansionEditPart.VISUAL_ID:
			return ExpansionViewFactory.class;
		case ExpansionNameEditPart.VISUAL_ID:
			return ExpansionNameViewFactory.class;
		case ConclusionEditPart.VISUAL_ID:
			return ConclusionViewFactory.class;
		case ConclusionNameEditPart.VISUAL_ID:
			return ConclusionNameViewFactory.class;
		case GlobalsEditPart.VISUAL_ID:
			return GlobalsViewFactory.class;
		case ExpressionEditPart.VISUAL_ID:
			return ExpressionViewFactory.class;
		case RootEditPart.VISUAL_ID:
			return RootViewFactory.class;
		case OrOperatorEditPart.VISUAL_ID:
			return OrOperatorViewFactory.class;
		case AndOperatorEditPart.VISUAL_ID:
			return AndOperatorViewFactory.class;
		case ConditionTermEditPart.VISUAL_ID:
			return ConditionTermViewFactory.class;
		case Expression2EditPart.VISUAL_ID:
			return Expression2ViewFactory.class;
		case Expression3EditPart.VISUAL_ID:
			return Expression3ViewFactory.class;
		case Expression4EditPart.VISUAL_ID:
			return Expression4ViewFactory.class;
		case Expression5EditPart.VISUAL_ID:
			return Expression5ViewFactory.class;
		case Expression6EditPart.VISUAL_ID:
			return Expression6ViewFactory.class;
		case Expression7EditPart.VISUAL_ID:
			return Expression7ViewFactory.class;
		case Expression8EditPart.VISUAL_ID:
			return Expression8ViewFactory.class;
		case LoaderEditPart.VISUAL_ID:
			return LoaderViewFactory.class;
		case LoaderNameEditPart.VISUAL_ID:
			return LoaderNameViewFactory.class;
		case ConditionEditPart.VISUAL_ID:
			return ConditionViewFactory.class;
		case ConditionNameEditPart.VISUAL_ID:
			return ConditionNameViewFactory.class;
		case SyncActivitySynActivityPreconditionCompartmentEditPart.VISUAL_ID:
			return SyncActivitySynActivityPreconditionCompartmentViewFactory.class;
		case SyncActivitySynActivityPostconditionCompartmentEditPart.VISUAL_ID:
			return SyncActivitySynActivityPostconditionCompartmentViewFactory.class;
		case ExpressionExpressionCompartmentEditPart.VISUAL_ID:
			return ExpressionExpressionCompartmentViewFactory.class;
		case ExpressionExpressionCompartment2EditPart.VISUAL_ID:
			return ExpressionExpressionCompartment2ViewFactory.class;
		case ListenerListenerPreconditionCompartmentEditPart.VISUAL_ID:
			return ListenerListenerPreconditionCompartmentViewFactory.class;
		case ExpressionExpressionCompartment3EditPart.VISUAL_ID:
			return ExpressionExpressionCompartment3ViewFactory.class;
		case AsyncActivityAsyncActivityPreconditionCompartmentEditPart.VISUAL_ID:
			return AsyncActivityAsyncActivityPreconditionCompartmentViewFactory.class;
		case AsyncActivityAsyncActivityPostconditionCompartmentEditPart.VISUAL_ID:
			return AsyncActivityAsyncActivityPostconditionCompartmentViewFactory.class;
		case ExpressionExpressionCompartment4EditPart.VISUAL_ID:
			return ExpressionExpressionCompartment4ViewFactory.class;
		case ExpressionExpressionCompartment5EditPart.VISUAL_ID:
			return ExpressionExpressionCompartment5ViewFactory.class;
		case EventEventPostconditionCompartmentEditPart.VISUAL_ID:
			return EventEventPostconditionCompartmentViewFactory.class;
		case ExpressionExpressionCompartment6EditPart.VISUAL_ID:
			return ExpressionExpressionCompartment6ViewFactory.class;
		case ExpansionExpansionPostconditionCompartmentEditPart.VISUAL_ID:
			return ExpansionExpansionPostconditionCompartmentViewFactory.class;
		case ExpressionExpressionCompartment7EditPart.VISUAL_ID:
			return ExpressionExpressionCompartment7ViewFactory.class;
		case ConclusionConclusionPostconditionCompartmentEditPart.VISUAL_ID:
			return ConclusionConclusionPostconditionCompartmentViewFactory.class;
		case ExpressionExpressionCompartment8EditPart.VISUAL_ID:
			return ExpressionExpressionCompartment8ViewFactory.class;
		case GlobalsGlobalsLoaderCompartmentEditPart.VISUAL_ID:
			return GlobalsGlobalsLoaderCompartmentViewFactory.class;
		case GlobalsGlobalsConditionCompartmentEditPart.VISUAL_ID:
			return GlobalsGlobalsConditionCompartmentViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (elementType != null
				&& !New_processElementTypes.isKnownElementType(elementType)) {
			return null;
		}
		if (New_processElementTypes.AsyncActivityActor_4001.equals(elementType)) {
			return AsyncActivityActorViewFactory.class;
		}
		if (New_processElementTypes.RootTerm_4002.equals(elementType)) {
			return RootTermViewFactory.class;
		}
		if (New_processElementTypes.OperatorTermSubTerm_4003
				.equals(elementType)) {
			return OperatorTermSubTermViewFactory.class;
		}
		if (New_processElementTypes.ConditionTermConditionProxy_4004
				.equals(elementType)) {
			return ConditionTermConditionProxyViewFactory.class;
		}
		if (New_processElementTypes.ConclusionConclusionProxy_4005
				.equals(elementType)) {
			return ConclusionConclusionProxyViewFactory.class;
		}
		if (New_processElementTypes.ExpansionExpansionProxy_4006
				.equals(elementType)) {
			return ExpansionExpansionProxyViewFactory.class;
		}
		EClass semanticType = getSemanticEClass(semanticAdapter);
		if (semanticType == null) {
			return null;
		}
		EObject semanticElement = getSemanticElement(semanticAdapter);
		int linkVID = New_processVisualIDRegistry.getLinkWithClassVisualID(
				semanticElement, semanticType);
		switch (linkVID) {
		}
		return getUnrecognizedConnectorViewClass(semanticAdapter,
				containerView, semanticHint);
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}

	/**
	 * @generated
	 */
	private Class getUnrecognizedConnectorViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		// Handle unrecognized child node classes here
		return null;
	}

}
