/**
 * 
 */
package core;

import org.eclipse.gef.EditPart;

/** <p>an info object that holds the information that is passed from
 * the user to the refactoring.</p> Primarilly used by Model Refactoring.
 *
 * @author sh
 */
public class ModelInfo {
	// the old full qualified name of the implementation
	private String oldImplementation;
	
	// the new full qualified name of the implementation
	private String newImplementation;
	
	// the current selected EditPart
	private EditPart selectedEditPart;
	
	public String getOldImplementation() {
		return oldImplementation;
	}

	public void setOldImplementation(final String oldImplementation) {
		this.oldImplementation = oldImplementation;
	}

	public String getNewImplementation() {
		return newImplementation;
	}

	public void setNewImplementation(final String newImplementation) {
		this.newImplementation = newImplementation;
	}

	public EditPart getSelectedEditPart() {
		return selectedEditPart;
	}

	public void setSelectedEditPart(final EditPart selectedEditPart) {
		this.selectedEditPart = selectedEditPart;
	}
}
