/**
 * 
 */
package core;

import org.eclipse.ltk.core.refactoring.participants.ProcessorBasedRefactoring;
import org.eclipse.ltk.core.refactoring.participants.RefactoringProcessor;

/** <p>Needed for all kind of Refactorings.</p>
*
* <p>All the actual work is done in the processor, so we just have to 
* keep a reference to one here.<p>
*
* @author sh
*/
public class RenameProcessorHolder extends ProcessorBasedRefactoring {

	private final RefactoringProcessor processor;

	public RenameProcessorHolder(final RefactoringProcessor processor) {
		super(processor);
	    this.processor = processor;
	}
	  	  
	/**
	 * interface methods of ProcessorBasedRefactoring
	 */
	public RefactoringProcessor getProcessor() {
		return processor;
	}
}
