/**
 * 
 */
package gui.section;


import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import diagram.section.EnvEntry;


/**
 * @author sh
 *
 */
public class EnvEntriesLabelProvider extends LabelProvider implements
		ITableLabelProvider {
	
	public Image getColumnImage(Object element, int columnIndex) {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object, int)
	 */
	public String getColumnText(Object element, int columnIndex) {
		String result = "";
		EnvEntry envEntry = (EnvEntry)element; 
		switch (columnIndex) {
			case 0 :
				result = envEntry.getName(); // ENV_ENTRY_NAME_COLUMN
				break;
			case 1 :
				result = envEntry.getType(); // "ENV_ENTRY_TYPE_COLUMN"
				break;
			case 2 :
				result = envEntry.getValue(); // "ENV_ENTRY_VALUE_COLUMN"
				break;
			default :
				break; 	
		}
		return result;
	}
}
