/*
 * $Id: AssignmentListener.java 524 2005-09-20 11:16:02Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern;

import org.concern.AssignmentEvent;

import java.util.*;

/**
 * @author hengels
 * @version $Revision: 524 $
 */
public interface AssignmentListener
    extends EventListener
{
    void assigned(AssignmentEvent event);
    void unassigned(AssignmentEvent event);
}
