/*
 * $Id: LoaderException.java 842 2007-02-08 12:25:27Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern;

/**
 * Thrown by the loader, when loading of subjects fails due to a general error.
 *
 * @author hengels
 * @version $Revision: 842 $
 */
public class LoaderException extends ControllerException {
    public LoaderException(String message) {
        super(message);
    }

    public LoaderException(Throwable cause) {
        super(cause);
    }

    public LoaderException(String message, Throwable cause) {
        super(message, cause);
    }
}
