package org.concern;

/**
 * @author hengels
 * @version $Revision$
 */
public class Message
{
    String name;
    String fromProcess;
    String fromSubject;
    long timestamp;

    public Message() {
    }

    public Message(String name, String fromProcess, String fromSubject) {
        this.name = name;
        this.fromProcess = fromProcess;
        this.fromSubject = fromSubject;
        this.timestamp = System.currentTimeMillis();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getFromProcess() {
        return fromProcess;
    }

    public void setFromProcess(String fromProcess) {
        this.fromProcess = fromProcess;
    }

    public String getFromSubject() {
        return fromSubject;
    }

    public void setFromSubject(String fromSubject) {
        this.fromSubject = fromSubject;
    }

    public long getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(long timestamp) {
        this.timestamp = timestamp;
    }

    public String toString() {
        return "[" + fromProcess + ":" + fromSubject + "] " + name;
    }
}
