package org.concern;

/**
 * Thrown by a persister, when storing of subjects fails due to a general error.
 *
 * @author hengels
 * @version $Revision: 668 $
 */
public class PersisterException extends LoaderException {
    public PersisterException(String message) {
        super(message);
    }

    public PersisterException(Throwable cause) {
        super(cause);
    }

    public PersisterException(String message, Throwable cause) {
        super(message, cause);
    }
}
