/*
 * $Id: BatchCommand.java 674 2006-10-06 12:15:59Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.client.commandline;

/**
 * @version $Revision: 674 $
 */
public class BatchCommand extends Command
{
    Command[] commands;

    public Command[] getCommands() {
        return commands;
    }

    public void setCommands(Command[] commands) {
        this.commands = commands;
    }

    public void run() {
        for (int i = 0; i < commands.length; i++) {
            Command command = commands[i];
            command.setController(controller);
            command.run();
        }
    }
}
