/*
 * $Id: AbstractActor.java 911 2007-02-20 13:53:49Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;


/**
 * @author hengels
 * @version $Revision: 911 $
 */
public abstract class AbstractActor<S>
    extends AbstractNode
    implements Actor<S>
{
    public String getName() {
        return (String)environment.get("actor.name");
    }

    public long getTimeout(S subject, int level) {
        return -1;
    }
}
