/*
 * $Id: AbstractCondition.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

import org.concern.*;

import java.util.List;
import java.util.Iterator;

import org.hibernate.LockMode;
import org.hibernate.HibernateException;


public abstract class AbstractCondition<S>
    extends AbstractNode
    implements Condition<S>
{
    protected AbstractCondition() {
    }

    protected AbstractCondition(String name) {
        getEnvironment().put("condition.name", name);
    }

    public final String getName() {
        return (String)environment.get("condition.name");
    }
}
