/*
 * $Id: AbstractTemporalCondition.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

/**
 * @author hengels
 * @version $Revision: 881 $
 */
public abstract class AbstractTemporalCondition<S>
    extends AbstractCondition<S>
    implements TemporalCondition<S>
{
    protected AbstractTemporalCondition() {
    }

    protected AbstractTemporalCondition(String name) {
        super(name);
    }
}
