/*
 * $Id: Loader.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

/**
 * The condition evaluates a separatly statable property of the subject. The pre- and postconditions of
 * activities and exits are boolean expression over a set of those conditions.
 * @version $Revision: 881 $
 */
public interface Loader<S>
    extends Node, org.concern.Loader<S>
{
}
