//$Id: ControllerServiceMBean.java 667 2006-04-25 08:01:58Z hengels $
package org.concern.controller.jmx;

import org.concern.Controller;
import org.concern.ControllerException;

/**
 * @see ControllerService
 * @author hengels
 */
public interface ControllerServiceMBean
    extends Controller
{
    /**
     * Create the <tt>Controller</tt> and bind to the jndi name on startup
     */
    public void start() throws ControllerException;
    /**
     * Unbind the <tt>SessionFactory</tt> or stub from JNDI
     */
    public void stop();

    String getJndiName();

    void setJndiName(String jndiName);

    String getTransactionManagerJndiName();

    void setTransactionManagerJndiName(String transactionManagerJndiName);

    String getSessionFactoryJndiName();

    void setSessionFactoryJndiName(String sessionFactoryJndiName);

    long getTimerInterval();

    void setTimerInterval(long timerInterval);

    void setResourceLocatorClassName(String name);

    String getResourceLocatorClassName();

    String getProcessDescription();

    void setProcessDescription(String processDescription);

    String getParameterResolverClassName();

    void setParameterResolverClassName(String parameterResolverClassName);
}
