package org.concern.controller.spring;

import org.concern.controller.ParameterResolver;
import org.concern.model.EnvironmentEntry;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
public class LocalParameterResolver
    implements ParameterResolver
{
    Map parameters;

    public LocalParameterResolver(Map parameters) {
        this.parameters = parameters;
    }

    public Object resolve(String process, String name, String type) {
        Object value = parameters.get(name);
        if (value != null && !value.getClass().getName().equals(type) && value instanceof String)
            value = EnvironmentEntry.createInstance(type, (String)value);
        return value;
    }
}
