package org.concern.controller.spring;

import org.concern.controller.ResourceLocator;

import java.util.Map;
import java.util.HashMap;
import org.concern.controller.Controller;

public class LocalResourceLocator
    implements ResourceLocator
{
    private Controller controller;
    
    Map resources = new HashMap();
    
    public LocalResourceLocator() {
    }

    public LocalResourceLocator(Map resources) {
        this.resources = resources;
    }

    public Map getResources() {
        return resources;
    }

    public void setResources(Map resources) {
        this.resources = resources;
    }

    public Object lookup(String name) {
        return resources.get(name);
    }

    public void setController(Controller controller) {
        this.controller = controller;
    }
}
