package org.concern.model;



public class Loader
    extends Element
    implements Implementable
{
    String implementation = "";

    public Loader() {
        super(null);
    }

    public Loader(String name) {
        super(name);
    }

    public Loader(String name, String implementation) {
        super(name);
        this.implementation = implementation;
    }

    public String getImplementation() {
        return implementation;
    }

    public void setImplementation(String implementation) {
        Object old = this.implementation;
        this.implementation = implementation;
        changes.firePropertyChange("implementation", old, implementation);
    }
}
