/*
 * $Id: ProcessChangeListener.java 479 2005-07-19 16:40:01Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model;

import java.util.EventListener;

/**
 * @version $Revision: 479 $
 */
public interface ProcessChangeListener extends EventListener
{
    void nodeAdded(ProcessChangeEvent event);
    void nodeRemoved(ProcessChangeEvent event);
    void nodeChanged(ProcessChangeEvent event);
}
