package org.concern.controller;

public class DummyAsynchronousActivity
    extends AbstractAsynchronousActivity
{
    public DummyAsynchronousActivity() {
    }

    public DummyAsynchronousActivity(String name) {
        super(name);
        environment.put("activity.precondition", name);
        environment.put("activity.postcondition", "");
        environment.put("activity.reentrant", Boolean.TRUE);
    }

    public void enlist(Object subject) throws ActivityExecutionException {
        System.out.println("enlist " + getName() + " on " + subject);
    }

    public void delist(Object subject) throws ActivityExecutionException {
        System.out.println("delist " + getName() + " on " + subject);
    }

    Integer dummy;

    public void setDummy(Integer dummy) {
        this.dummy = dummy;
    }

    public Integer getDummy() {
        return dummy;
    }
}
