package org.conform;


public interface BeanValidator
    extends Validator
{
    /**
     * The validator inspects these properties only. This information is used to map bean level validation issues to
     * properties (not only) in visual environments. For the sake of optimization, the validator might be called only,
     * if an affected property has changed and all affected properties don't have issues.
     * @return the names of the affected properties
     */
    String[] getAffectedPropertyNames();
}
