package org.conform;

import org.conform.format.Format;

import java.io.Serializable;
import java.util.Map;

/**
 * Holds meta information of a type.
 */
public interface Meta
    extends Serializable, Cloneable
{
    String getName();
    void setName(String name);
    Class getType();
    void setType(Class type);
    Format getFormat();
    void setFormat(Format format);

    public String getMicroHelp();
    public void setMicroHelp(String microHelp);
    public String getLabel();
    public void setLabel(String label);

    void setAttribute(String name, Object value);
    Object getAttribute(String name);
    Map getAttributes();
    void setAttributes(Map attributes);
}
