/* $Id: BigIntegerFormat.java 652 2006-01-19 11:12:50Z hengels $ */
package org.conform.format;

import java.text.*;
import java.math.*;


/**
 * java.sql.Date
 * @version $Revision: 652 $
 */
public class BigIntegerFormat extends AbstractFormat
{
    public BigIntegerFormat() {
        message = "validation.unparsableNumber";
        help = "+/-3456";
    }

    public String getPattern() {
        return "#";
    }

    public void setPattern(String pattern) {}

    public String format(Object value) {
        return value.toString();
    }

    public Object parse(String string) throws ParseException {
        try {
            return new BigInteger(string);
        }
        catch (NumberFormatException e) {
            throw new ParseException(string, 0);
        }
    }
}
