/* $Id: TranslationFormat.java 652 2006-01-19 11:12:50Z hengels $ */
package org.conform.format;

import java.util.*;

/**
 * @version $Revision: 652 $
 */
public class TranslationFormat extends AbstractFormat
{
    Map translations = new HashMap();

    public String getPattern() {
        return "%";
    }

    public void setPattern(String pattern) {}

    public String format(Object value) {
        String text = (String)translations.get(value);
        if (text != null)
            return text;
        return "" + value;
    }

    public void addTranslation(Object value, String translation) {
        translations.put(value, translation);
    }
}
