package org.conform.mdl;

import org.xml.sax.*;

import java.beans.ExceptionListener;

/**
 * Created by IntelliJ IDEA.
 * User: nina
 * Date: 24.08.2003
 * Time: 11:16:04
 * To change this template use Options | File Templates.
 */
public class ScopeHandler
    extends HandlerBase
{
    protected Object scope;
    protected ExceptionListener exceptionListener;
    protected Locator locator;
    private HandlerFactory handlerFactory;

    public ScopeHandler(ExceptionListener exceptionListener) {
        this.exceptionListener = exceptionListener;
    }

    public void setDocumentLocator(Locator locator) {
        this.locator = locator;
    }

    public Object getScope() {
        return scope;
    }

    public void setScope(Object scope) {
        this.scope = scope;
    }

    protected ScopeHandler getHandler(String name) {
        if (handlerFactory == null)
            handlerFactory = DefaultHandlerFactory.getInstance();

        return handlerFactory.getHandler(name);
    }
}
