package org.conform.validator;

import java.lang.annotation.*;

@Target ({ ElementType.FIELD})
@Retention (RetentionPolicy.RUNTIME)
@ValidatorImplementation ( CLASS = DateRangeValidator.class )
public @interface DateRange
{
    DateRangeType from() default DateRangeType.NONE;
    DateRangeType until() default DateRangeType.NONE;
}
