package org.conform.validator;

import java.lang.annotation.*;

@Target ({ ElementType.FIELD})
@Retention (RetentionPolicy.RUNTIME)
@ValidatorImplementation ( CLASS = NumberRangeValidator.class )
public @interface NumberRange
{
    String from() default "";
    boolean fromInclusive() default false;

    String until() default "";
    boolean untilInclusive() default false;
}
