package org.conform.validator;

import java.lang.annotation.*;

@Target ({ ElementType.FIELD})
@Retention (RetentionPolicy.RUNTIME)
@ValidatorImplementation ( CLASS = RegularExpressionValidator.class )
public @interface RegularExpression
{
    RegularExpressionType type() default RegularExpressionType.CUSTOM;
    String expression() default ".*";
}
