package org.conform.validator;

import java.lang.annotation.*;

@Target ({ ElementType.FIELD})
@Retention (RetentionPolicy.RUNTIME)
@ValidatorImplementation ( CLASS = TimeRangeValidator.class )
public @interface TimeRange
{
    TimeRangeType from() default TimeRangeType.NONE;
    TimeRangeType until() default TimeRangeType.NONE;
}
