
/* $Id: Editor.java 746 2006-11-08 13:34:23Z hengels $ */
package org.conform.wings;

import org.conform.*;
import org.wings.SComponent;

public interface Editor {

    static final String CUSTOM_EDITOR = "custom.editor";
    static final String ACTIONS = "editor.actions";

    SComponent createComponent(PropertyMeta propertyMeta);
    void configureComponent(PropertyMeta propertyMeta, SComponent component, boolean erroneous);

    PropertyData getPropertyData(SComponent component);
    void setPropertyData(SComponent component, PropertyData propertyData);
}
