/* $Id: NoEditorException.java 652 2006-01-19 11:12:50Z hengels $ */
package org.conform.wings;


import org.conform.PropertyMeta;

public class NoEditorException
    extends RuntimeException
{
    private PropertyMeta field;

    public NoEditorException(PropertyMeta field) {
        super(field.getName());
        this.field = field;
    }

    public NoEditorException(Throwable cause, PropertyMeta field) {
        super(cause);
        this.field = field;
    }

    public PropertyMeta getField() {
        return field;
    }
}
