package org.conform.wings.editor;

import javax.swing.event.ChangeListener;
import java.util.Set;

public interface SubSetModel {
    Set getWholeSet();
    void setWholeSet(Set set);

    Set getIncludedSubSet();
    void setIncludedSubSet(Set set);
    Set getExcludedSubSet();
    void setExcludedSubSet(Set set);

    void include(Object object);
    void exclude(Object object);

    boolean isIncluded(Object object);
    boolean isExcluded(Object object);

    void addChangeListener(ChangeListener listener);
    void removeChangeListener(ChangeListener listener);
}
