package org.osbl.inventory;

import org.osbl.*;
import org.osbl.inventory.model.Inventory;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;
import org.hibernate.Hibernate;

import java.util.*;

public class InventoryLocator
    extends PersistenceObjectLocator<Inventory>
{
    protected String getPersistenceServiceName() {
        return "InventoryPersistence";
    }

    protected Class getObjectClass() {
        return Inventory.class;
    }

    protected void initialize(Inventory object) {
        Hibernate.initialize(object);
        Hibernate.initialize(object.getLocation());
        Hibernate.initialize(object.getCostType());
    }
}
