package org.osbl.inventory.logic;

import org.osbl.inventory.model.CostType;
import org.osbl.inventory.model.CostTypeHierarchy;
import org.osbl.persistence.logic.DefaultTreeLogic;

/**
 * @author hengels
 * @version $Revision$
 */
public class DefaultInventoryLogic
    extends DefaultTreeLogic<CostTypeHierarchy, CostType>
    implements InventoryLogic
{
    protected String getNodeType() {
        return CostType.class.getName();
    }

    protected String getTreeType() {
        return CostTypeHierarchy.class.getName();
    }
}
