package org.osbl.inventory.model;

import org.osbl.persistence.model.Entity;
import org.osbl.persistence.model.TreeNodeEntity;
import org.conform.Property;

import java.sql.Date;

/**
 * @author hengels
 * @version $Revision: 840 $
 */
public class CostType
    extends TreeNodeEntity<CostTypeHierarchy>
{
    @Property (mandatory = "true")
    Date validFrom;
    Date validUntil;

    @Property (mandatory = "true")
    String name;
    String description;


    public Date getValidFrom() {
        return validFrom;
    }

    public void setValidFrom(Date validFrom) {
        this.validFrom = validFrom;
    }

    public Date getValidUntil() {
        return validUntil;
    }

    public void setValidUntil(Date validUntil) {
        this.validUntil = validUntil;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String toString() {
        return name;
    }
}
