package org.osbl.authorization.logic;

import org.osbl.identity.model.Identity;
import org.osbl.authorization.model.Profile;
import org.hibernate.*;
import org.concern.controller.Transactions;

import java.util.List;

public class DefaultAuthorizationLogic
    implements AuthorizationLogic
{
    private SessionFactory sessionFactory;

    public List<Identity> identitiesWithProfile(Profile profile) {
        Session session = sessionFactory.getCurrentSession();
        Query query = session.createQuery("select u.general from User u where :profile in elements(u.profiles)");
        query.setParameter("profile", profile);
        return (List<Identity>)query.list();
    }

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }
}
