package org.osbl.authorization.model;

public class Pattern
{
    PatternType type;
    String action;
    String pattern;

    public Pattern() {
    }

    public Pattern(PatternType type, String action, String pattern) {
        this.type = type;
        this.action = action;
        this.pattern = pattern;
    }

    public PatternType getType() {
        return type;
    }

    public void setType(PatternType type) {
        this.type = type;
    }

    public String getAction() {
        return action;
    }

    public void setAction(String action) {
        this.action = action;
    }

    public String getPattern() {
        return pattern;
    }

    public void setPattern(String pattern) {
        this.pattern = pattern;
    }

    public String toString() {
        return pattern + '[' + action + ']';
    }
}
