package org.osbl.identity.model;

import org.conform.Property;
import org.osbl.persistence.model.*;

import java.util.List;

public class Person
    extends Concrete<Identity>
{
    @Property (mandatory = "true")
    String firstName;
    @Property (mandatory = "true")
    String lastName;
    List<Address> addresses;
    Gender gender;

    public Person() {
    }

    public Person(Identity general) {
        super(general);
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public List<Address> getAddresses() {
        return addresses;
    }

    public void setAddresses(List<Address> addresses) {
        this.addresses = addresses;
    }

    public Gender getGender() {
        return gender;
    }

    public void setGender(Gender gender) {
        this.gender = gender;
    }
}
