package org.osbl.orga.logic;

import org.osbl.orga.model.*;
import org.osbl.persistence.logic.TreeLogic;

import java.util.*;
import java.sql.Timestamp;

/**
 * @author hengels
 * @version $Revision$
 */
public interface OrgaStructureLogic
    extends TreeLogic<Organisation, Group>
{
    List<Group> groupsByContainedGroup(Long tree, Long groupKey, String inRole);
    List<Group> groupsByContainedIdentity(Long tree, Long identityKey, String inRole);

    List<Membership> memberships(Long identity);

    List<Relationship> relationships(Long identity);

    int importMembers(Organisation organisation, String createdBy);
}
