package org.osbl.orga.model;

import org.osbl.persistence.model.TreeEntity;
import org.conform.Property;

import java.util.List;

public class Organisation
    extends TreeEntity
{
    @Property (mandatory = "true")
    String name;

    @Property (mandatory = "true")
    String groupType;
    @Property (mandatory = "true")
    String memberType;
    boolean active;

    List<String> roles;
    List<String> relations;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getGroupType() {
        return groupType;
    }

    public void setGroupType(String groupType) {
        this.groupType = groupType;
    }

    public String getMemberType() {
        return memberType;
    }

    public void setMemberType(String memberType) {
        this.memberType = memberType;
    }

    public boolean isActive() {
        return active;
    }

    public void setActive(boolean active) {
        this.active = active;
    }

    public List<String> getRoles() {
        return roles;
    }

    public void setRoles(List<String> roles) {
        this.roles = roles;
    }

    public List<String> getRelations() {
        return relations;
    }

    public void setRelations(List<String> relations) {
        this.relations = relations;
    }
}
