package org.osbl.orga.model;

import org.conform.Property;

public class Relationship
    implements Comparable
{
    Long id;
    @Property (mandatory = "true")
    Member member;
    @Property (mandatory = "true")
    Member peer;
    @Property (mandatory = "true")
    String relation;

    public Relationship() {
    }

    public Relationship(Member member, Member peer, String relation) {
        this.member = member;
        this.peer = peer;
        this.relation = relation;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Member getMember() {
        return member;
    }

    public void setMember(Member member) {
        this.member = member;
    }

    public Member getPeer() {
        return peer;
    }

    public void setPeer(Member peer) {
        this.peer = peer;
    }

    public String getRelation() {
        return relation;
    }

    public void setRelation(String relation) {
        this.relation = relation;
    }

    public int compareTo(Object o) {
        Relationship r = (Relationship)o;
        if (id == null && r.id != null)
            return 1;
        else if (id != null && r.id == null)
            return -1;
        else if (id == null && r.id == null)
            return 0;
        else
            return id.compareTo(r.id);
    }
}
