package org.osbl.demo.urlaub.gui;

import org.osbl.client.web.spring.SpringWebModule;
import org.osbl.ItemRegistry;
import org.osbl.item.BeanAuthorizationCollector;
import org.osbl.item.BeanLocalizationCollector;
import org.osbl.demo.urlaub.model.UrlaubsAntrag;
import org.osbl.client.ClientServiceProvider;
import org.osbl.client.wings.action.ShowToolAction;
import org.osbl.client.wings.action.QueryAction;
import org.osbl.client.wings.navigation.NavigationStructure;
import org.osbl.client.action.ActionRegistry;

public class UrlaubsAntragWebModule
    extends SpringWebModule
{
    ItemRegistry authorizationItems;
    ItemRegistry localizationItems;

    public void setAuthorizationItems(ItemRegistry authorizationItems) {
        this.authorizationItems = authorizationItems;
    }

    public void setLocalizationItems(ItemRegistry localizationItems) {
        this.localizationItems = localizationItems;
    }
    public void initialize() {
        authorizationItems.addItems(new BeanAuthorizationCollector(UrlaubsAntrag.class));
        localizationItems.addItems(new BeanLocalizationCollector(UrlaubsAntrag.class));
    }
}
