/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.demo.urlaub.process;


import org.concern.controller.AbstractActor;
import org.osbl.demo.urlaub.model.UrlaubsAntrag;

import java.util.*;

public class PersonalAbteilung
    extends AbstractActor<UrlaubsAntrag>
{
    public Set getAssignees(UrlaubsAntrag subject, int level) {
    	/*PROTECTED REGION ID(org.osbl.demo.urlaub.process.PersonalAbteilung.getAssignees) ENABLED START*/
        if (level > 3)
            return Collections.EMPTY_SET;
        
        return new HashSet(Arrays.asList(new String[]{"hm", "hr " + (level + 1)}));
        /*PROTECTED REGION END*/
    }
}
        