package org.osbl.demo.urlaub.process;

import org.concern.library.generic.FormClassNameActivity;
import org.concern.controller.ActivityExecutionException;
import org.osbl.demo.urlaub.model.UrlaubsAntrag;

/**
 * @author hengels
 * @version $Revision$
 */
public class Stornieren
    extends FormClassNameActivity<UrlaubsAntrag>
{
    public void enlist(UrlaubsAntrag subject) throws ActivityExecutionException {
    	/*PROTECTED REGION ID(org.osbl.demo.urlaub.process.Stornieren.enlist) ENABLED START*/
        try {
            System.out.println("enlist " + controller.getLoader().idOf(subject));
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        /*PROTECTED REGION END*/
    }

    public void delist(UrlaubsAntrag subject) throws ActivityExecutionException {
    	/*PROTECTED REGION ID(org.osbl.demo.urlaub.process.Stornieren.delist) ENABLED START*/
        try {
            System.out.println("delist " + controller.getLoader().idOf(subject));
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        /*PROTECTED REGION END*/
    }

    public void assign(UrlaubsAntrag subject, String assignee, int level) {
        try {
            System.out.println("assign " + controller.getLoader().idOf(subject) + " to " + assignee + " (" + level + ")");
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void unassign(UrlaubsAntrag subject, String assignee, int level) {
        try {
            System.out.println("unassign " + controller.getLoader().idOf(subject) + " to " + assignee + " (" + level + ")");
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
