/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.demo.urlaub.process;


import org.concern.controller.AbstractActor;
import org.osbl.demo.urlaub.model.UrlaubsAntrag;

import java.util.*;

public class Vorgesetzter
    extends AbstractActor<UrlaubsAntrag>
{
    public Set<String> getAssignees(UrlaubsAntrag subject, int level) {
    	/*PROTECTED REGION ID(org.osbl.demo.urlaub.process.Vorgesetzter.getAssignees) ENABLED START*/
        switch (level) {
            case 0:
                return new HashSet<String>(Arrays.asList("fy", "nh", "tw", "elh"));
            case 1:
                return new HashSet<String>(Arrays.asList("al"));
            default:
                return Collections.EMPTY_SET;
        }
        /*PROTECTED REGION END*/
    }
}
