/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.client;

import org.conform.BeanMetaProvider;
import org.conform.VariationBeanMetaProvider;

/**
 * @version $Revision: 1.7 $
 */
class SessionBeanMetaProvider
    extends VariationBeanMetaProvider
{
    FormatModifier formatModifier;

    public SessionBeanMetaProvider(BeanMetaProvider parent) {
        setParent(parent);
        addModifier(new LocalizationModifier(this));
        addModifier(new AuthorizationModifier(this));
        addModifier(new FormatModifier(this));
    }
}
