package org.osbl;

import java.util.List;

public abstract class ServiceProvider
{
    protected static ServiceProvider INSTANCE;

    public abstract List<String> getServiceNames();

    public abstract Object getService(String name);

    public abstract <T> T getService(Class<T> type);

    public abstract void autowireServices(Object bean);

    public static ServiceProvider getInstance() {
        return INSTANCE;
    }
}
