package org.osbl;

import org.conform.Issue;

import java.util.Collection;

public class ValidationIssueException
    extends RuntimeException
{
    Collection<Issue> issues;

    public ValidationIssueException(Collection<Issue> issues) {
        this.issues = issues;
    }

    public Collection<Issue> getIssues() {
        return issues;
    }

    @Override
    public String toString() {
        return issues.toString();
    }
}
