package org.osbl.agent.gui.condition;

import java.util.List;

import org.osbl.agent.model.condition.BinaryOperator;
import org.osbl.agent.model.condition.Operator;



/**
 * The Class NumberConditionController.
 * 
 * @author Sebastian Nozzi.
 */
public class NumberConditionController extends FieldConditionController {

	/**
	 * Instantiates a new number condition controller.
	 */
	public NumberConditionController() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.osbl.agent.gui.condition.FieldConditionController#getOperators()
	 */
	public List<Operator> getOperators() {

		// To the Operators defined by the superclas...
		List<Operator> result = super.getOperators();

		// ...add some number specific Operators like...
		
		// ...arithmetic relational Operators "less than", "greater than"...
		
		result.add(new BinaryOperator(msg("operatorLessThan"),"<"));
		result.add(new BinaryOperator(msg("operatorGreaterThan"),">"));

		return result;
	}

}
