package org.osbl.authorization;

import java.security.*;

public class ActionPermission
    extends BasicPermission
{
    String actions;

    public ActionPermission(String name, String actions) {
        super(name);
        this.actions = actions;
    }

    public String getActions() {
        return actions;
    }

    public PermissionCollection newPermissionCollection() {
        return new PatternPermissionCollection();
    }
}
