package org.osbl.authorization;

import java.security.Permission;
import java.security.PermissionCollection;

public interface Authorization
{
    boolean checkPermission(String userid, String permission, String action);
    PermissionCollection getPermissions(String userid);
    Permission getPermission(String userid, String permission);

    void clearCache(String userid);
}
