package org.osbl.client.action;

import javax.swing.Action;

/**
 * @author hengels
 * @version $Revision$
 */
public class StaticActionProvider
    implements ActionProvider
{
    public static final ActionProvider INSTANCE = new StaticActionProvider();

    private StaticActionProvider() {
    }

    public Action getAction(String name) {
        return ActionRegistry.getAction(name);
    }

    public Action configure(Action action) {
        return action;
    }
}
