package org.osbl.client.wings.action;

import org.wings.SIcon;
import org.wings.SComponent;
import org.osbl.client.wings.shell.Client;

import javax.swing.*;
import java.util.Map;
import java.awt.event.ActionEvent;
import java.lang.reflect.Constructor;

/**
 * @author hengels
 * @version $Revision: 1.2 $
 */
@Deprecated
public class ShowToolAction
    extends NavigationAction
{
    protected String className;
    private Map paramMap;

    public ShowToolAction(String className, String command, SIcon icon) {
        this(className, command);
        putValue(Action.SMALL_ICON, icon);
    }

    public ShowToolAction(String className, String command) {
        this.className = className;
        putValue(Action.ACTION_COMMAND_KEY, command);
        putValue(Action.SHORT_DESCRIPTION, command);
    }

    public ShowToolAction(String className, String command, Map paramMap) {
        this(className, command);
        this.paramMap = paramMap;
    }

    public Map getParamMap() {
        return paramMap;
    }

    public void setParamMap(Map paramMap) {
        this.paramMap = paramMap;
    }

    public void actionPerformed(ActionEvent event) {
        Client.getInstance().show("main", (SComponent)createComponentInstance(paramMap));
    }

    protected Object createComponentInstance(Map map) {
        try {
            ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
            Class cl = classLoader.loadClass(className);
            if (map != null) {
                Constructor ctor = cl.getConstructor(Map.class);
                return ctor.newInstance(map);
            }
            else
                return cl.newInstance();
        }
        catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }

    public void navigate(Object object)  {
        actionPerformed(new ActionEvent(this, -1, toString()));
    }

    public void navigate(Map<String,String> query) {
        actionPerformed(new ActionEvent(this, -1, toString()));
    }
}
