package org.osbl.client.wings.control;

import org.osbl.client.wings.shell.Tool;
import org.concern.Controller;
import org.concern.Subject;
import org.wings.SDimension;
import org.wings.SListSelectionModel;
import org.wingx.XScrollPane;
import org.wingx.XTable;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
class StateTable
    extends XScrollPane
    implements Plugin
{
    XTable table;
    StateTableModel stateModel;

    public StateTable() {
        stateModel = new StateTableModel();
        table = new XTable(stateModel);
        table.setEditable(false);
        table.setPreferredSize(SDimension.FULLWIDTH);
        table.setSelectionMode(SListSelectionModel.NO_SELECTION);
        setViewportView(table);
    }

    public void update() {
        stateModel.refresh();
    }

    public void setController(Controller controller) {
        stateModel.setController(controller);
    }

    public void setSubject(Subject subject) {
        stateModel.setSubject(subject);
    }

    public List<Tool> getTools() {
        return Collections.EMPTY_LIST;
    }
}
