package org.osbl.client.wings.devtools;

import org.osbl.client.ClientServiceProvider;
import org.osbl.ItemRegistry;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.util.List;
import java.util.Collections;

public class DumpItemRegistryDevTool
    extends AbstractAction
{
    protected static final String SERVICE = "SERVICE";

    public DumpItemRegistryDevTool(String name) {
        putValue(Action.NAME, name);
    }

    public void actionPerformed(ActionEvent e) {
        ItemRegistry localizationItems = (ItemRegistry)ClientServiceProvider.getInstance().getService((String)getValue(SERVICE));
        List<String> items = localizationItems.getItems();
        Collections.sort(items);
        for (String item : items) {
            System.out.println(item);
        }
    }
}
