package org.osbl.client.wings.form;

import org.osbl.client.wings.form.layouter.Instruction;
import org.osbl.client.wings.form.GenericObjectForm;
import org.osbl.client.wings.form.ObjectForm;
import org.conform.BeanMeta;
import org.wings.SComponent;

public abstract class GenericObjectSubForm
    implements ObjectSubForm
{
    ObjectForm objectForm;
    protected int viewMode = ObjectForm.EDIT;

    public void setObjectForm(ObjectForm objectForm) {
        this.objectForm = objectForm;
    }

    public void setViewMode(int viewMode) {
        this.viewMode = viewMode;
    }

    public void initializeSubForm() {}

    public void setObject(Object object) {
    }

    public abstract Object getObject(String path);
    public abstract void setObject(String path, Object object);

    public abstract BeanMeta createBeanMeta(String path);

    public SComponent createCustomComponent(String key) {
        return null;
    }

    /**
     * It's the subForm's job to append its layout to the main layout.
     * @param mainInstruction the extendable conform's layout instructions
     */
    public abstract void appendLayoutInstructions(Instruction mainInstruction);

    protected GenericObjectForm getGenericObjectForm() {
        return ((GenericObjectForm)objectForm);
    }
}
