package org.osbl.client.wings.form;

import org.wings.*;
import org.wingx.table.EditableTableCellRenderer;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class StringEditableCellRenderer
    extends STextField
    implements EditableTableCellRenderer, ActionListener
{
    public StringEditableCellRenderer() {
        addActionListener(this);
    }

    public Object getValue() {
        String s = getText();
        if ("".equals(s))
            return null;
        return s;
    }

    public SComponent getTableCellRendererComponent(STable table, Object value, boolean isSelected, int row, int column) {
        setEditable(table.isEnabled());
        setText((String)value);
        return this;
    }

    public LowLevelEventListener getLowLevelEventListener(STable table, int row, int column) {
        return this;
    }

    public void actionPerformed(ActionEvent e) {
    }
}
