package org.osbl.client.wings.form.format;

import org.conform.format.*;

import java.util.Locale;
import java.text.ParseException;

public class LocalizationFormat
    extends AbstractFormat
{
    private static LocalizationFormat INSTANCE;

    public static LocalizationFormat getInstance() {
        if (INSTANCE == null)
            INSTANCE = new LocalizationFormat();

        return INSTANCE;
    }

    public String format(Object value) {
        FormatFactory formatFactory = FormatFactory.getInstance();
        Locale locale = formatFactory.getLocale();
        ResourceProvider resourceProvider = formatFactory.getResourceProvider();
        return value != null ? resourceProvider.getMessage(locale, value.toString()) : "";
    }

    public Object parse(String string) throws ParseException {
        return null;
    }

    public String getMessage() {
        return null;
    }

    public String getHelp() {
        return null;
    }
}
