package org.osbl.client.wings.form.layouter;

import org.wings.border.*;
import org.wings.*;
import org.osbl.client.wings.form.ComponentProvider;

import java.awt.*;

/**
 * Place an empty line.
 */
public class EmptyLine
    extends Line
{
    public GridBagConstraints editorConstraints = new GridBagConstraints();
    {
        editorConstraints = new GridBagConstraints();
        editorConstraints.anchor = GridBagConstraints.NORTH;
        editorConstraints.insets = EMPTY_LINE_INSETS;
        editorConstraints.gridwidth = GridBagConstraints.REMAINDER;
    }

    /**
     * Construct an empty line placement description.
     */
    public EmptyLine() {
    }

    public void build(ComponentProvider componentProvider, SContainer container) {
        SComponent propertyComponent = new SLabel("<html>&nbsp;");
        propertyComponent.putClientProperty("instruction", this);
        container.add(propertyComponent, editorConstraints);
    }
}
