package org.osbl.client.wings.form.layouter;

import org.wings.SDimension;

import java.awt.*;

/**
 * Arranges Components.
 */
public abstract class Line implements Element {
    protected static final SDimension LABEL_SIZE = new SDimension("140px", "20px");
    protected static final Insets LINE_INSETS = new Insets(0, 0, 4, 0);
    protected static final Insets EMPTY_LINE_INSETS = new Insets(4, 0, 4, 0);

    public double weight = 0d;

    protected Line() {
    }

    /**
     * Construct a structural description of a Line.
     * @param weight how much of the available vertical space should the line span
     */
    protected Line(double weight) {
        this.weight = weight;
    }
}
