package org.osbl.client.wings.shell;

import org.wings.SComponent;
import org.wings.SButton;

import javax.swing.*;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: hengels
 * Date: Dec 15, 2006
 * Time: 10:49:04 AM
 * To change this template use File | Settings | File Templates.
 */
public interface Environment
{
    void setContentPane(SComponent contentPane);

    void setDefaultButton(SButton button);

    void setTitle(String titleCode, Object... titleArguments);

    void addControl(SComponent component);

    void removeControl(SComponent component);

    void setControls(List<SComponent> controls);

    void addTool(Tool tool);

    void removeTool(Tool tool);

    void setTools(List<Tool> tools);

    void addDevelopmentAction(Action action);

    void removeDevelopmentAction(Action action);

    void setDevelopmentActions(List<Action> actions);

    void setStatusMessage(Client.Message statusMessage);

    void setDelegate(Environment delegate);

    Environment getDelegate();

    boolean isActive();

    void setActive(boolean active);

    boolean getHasChanges();

    void setHasChanges(boolean hasChanges);
}
