package org.osbl.concern;

import org.osbl.ObjectLocator;
import org.concern.Controller;
import org.concern.ControllerLookup;
import org.concern.model.Process;

import java.util.Map;
import java.util.HashMap;

public class ProcessLocator
    implements ObjectLocator<org.concern.model.Process>
{
    public org.concern.model.Process objectByQuery(Map<String,String> query) {
        String process = query.get("process");
        Controller controller = ControllerLookup.getInstance().getController(process);
        return controller.getProcess();
    }

    public Map<String,String> queryByObject(org.concern.model.Process process) {
        Map<String,String> map = new HashMap<String,String>();
        map.put("process", process.getName());
        return map;
    }
}
