package org.osbl.concern;

import org.osbl.ObjectLocator;
import org.concern.*;

import java.util.Map;
import java.util.HashMap;

public class TaskLocator
    implements ObjectLocator<Work>
{
    public Work objectByQuery(Map<String,String> query) {
        String process = query.get("process");
        String subjectId = query.get("subject");
        String activity = query.get("activity");
        String locale = query.get("locale");
        return ControllerLookup.getInstance().getWorklist().getWork(process, subjectId, activity, locale);
    }

    public Map<String,String> queryByObject(Work work) {
        Map<String,String> map = new HashMap<String,String>();
        map.put("process", work.getProcess());
        map.put("subject", work.getSubjectId());
        map.put("activity", work.getActivity());
        return map;
    }
}
