package org.osbl.persistence.hibernate;

import org.osbl.persistence.Persistence;
import org.hibernate.SessionFactory;

public class HibernatePersistence<C extends HibernateCommand>
    extends Persistence<C>
{
    SessionFactory sessionFactory;

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    protected void initializeCommand(C command) {
        command.setSessionFactory(sessionFactory);
    }
}
