package org.osbl.persistence.model;

import org.conform.format.AbstractFormat;
import org.conform.format.Format;
import org.osbl.persistence.model.TreeNodeEntity;

public class TreeNodeEntityFormat
    extends AbstractFormat
{
    static final String[] INDENTION = new String[] {
        "",
        "  ",
        "    ",
        "      ",
        "        ",
    };

    Format format;

    public TreeNodeEntityFormat(Format format) {
        this.format = format;
    }

    public String format(Object value) {
        if (value == null)
            return null;

        TreeNodeEntity treeNodeEntity = (TreeNodeEntity)value;
        return INDENTION[treeNodeEntity.getDepth() - 1] + format.format(value);
    }
}
