package org.osbl.plugin;

public class Extension
{
    protected String name;
    protected String type;
    protected Class implementation;

    protected Extension() {}

    public Extension(String name, String type, Class implementation) {
        this.name = name;
        this.type = type;
        this.implementation = implementation;
    }

    public String getName() {
        return name;
    }

    public String getType() {
        return type;
    }

    public Class getImplementation() {
        return implementation;
    }

    public String toString() {
        return "Extension{"+
            "name='"+name+'\''+
            ", type='"+type+'\''+
            '}';
    }
}
