package org.osbl.riskmanagement;

import org.osbl.*;
import org.osbl.riskmanagement.model.Risk;
import org.osbl.riskmanagement.model.RiskType;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;
import org.hibernate.Hibernate;

import java.util.*;

public class RiskTypeLocator
    extends PersistenceObjectLocator<RiskType>
{
    protected String getPersistenceServiceName() {
        return "RiskManagementPersistence";
    }

    protected Class getObjectClass() {
        return RiskType.class;
    }
}
