package org.osbl.riskmanagement.gui.report;

import org.osbl.client.wings.form.GenericObjectTreeModel;
import org.osbl.persistence.Persistence;
import org.osbl.ServiceProvider;
import org.osbl.riskmanagement.logic.RiskManagementLogic;
import org.osbl.riskmanagement.model.*;

/**
 * @author hengels
 * @version $Revision$
 */
public class RiskTreeModel
    extends GenericObjectTreeModel
{
    Persistence persistence = (Persistence)ServiceProvider.getInstance().getService("RiskManagementPersistence");
    RiskManagementLogic riskManagementLogic = (RiskManagementLogic)ServiceProvider.getInstance().getService("RiskManagementLogic");

    {
        map.put(Risk.class, RiskTreeTableNode.class);
    }

    public RiskTreeModel() {
        super(new RootTreeTableNode());
        getRoot().setModel(this);
    }

    public RiskManagementLogic getTreeLogic() {
        return riskManagementLogic;
    }

    public Persistence getPersistence() {
        return persistence;
    }
}
