package org.osbl.riskmanagement.model;

import org.conform.format.AbstractFormat;

public class RiskFormat
    extends AbstractFormat
{
    public String format(Object value) {
        Risk risk = (Risk)value;
        RiskType riskType = risk.getType();
        if (riskType != null) {
            String name = riskType.getName();
            return (name != null ? name : riskType.getKey()) + " " + risk.getKey();
        }
        else
            return risk.getKey();
    }
}
