package org.osbl.riskmanagement.process;


import org.concern.controller.AbstractActor;

import org.osbl.riskmanagement.model.Risk;
import org.osbl.identity.model.Identity;
import org.osbl.identity.model.User;
import org.osbl.persistence.*;

import java.util.*;

public class Responsible
    extends AbstractActor<Risk>
{
    Persistence identityPersistence;

    public void setIdentityPersistence(Persistence identityPersistence) {
        this.identityPersistence = identityPersistence;
    }

    public Set<String> getAssignees(Risk subject, int level) {
    	/*PROTECTED REGION ID(org.osbl.riskmanagement.process.Responsible.getAssignees) ENABLED START*/
        Identity responsible = subject.getType().getResponsible();
        LoadCommand command = (LoadCommand)identityPersistence.createCommand("load");
        command.setType(User.class);
        command.setId(responsible.getId());
        User user = (User)command.execute();
        return new HashSet<String>(Arrays.asList(user.getAccount()));
        /*PROTECTED REGION END*/
    }
}
